<?php

/**
 * @improved by Arbora Sergey (http://arbora.ru)
 *
 * Класс для возможности скрытия/отображения сервисов на сайте
 * Пока сервисы берутся из базы и не редактируются.
 * в будующем продумать общую схему добавления/удаления сервисов из списка.
 *
 */

class loader extends Module{

    public static $table = 'load_service';

    public $service = array();

    private $_id;

    public function setId($id){
        $this->_id = $id;
    }
    
    function load(){
        $_data = $this->db->query('SELECT * FROM :table ORDER BY `name`',array('table'=>db_name(self::$table)),db::FETCH_ALL);
        if (!empty($_data)) foreach ($_data as $item) {
            $this->service[$item['service']] = $item;
        }
        return $this->service;
    }

    /**
     * Проверка на активность сервиса. 
     * возарвщвет false в случае если сервис не активен, но существует.
     * true при любых других резултатах (нет в саписке или активен)
     * @param string $name
     */
    public function serviceActive($name){
        if (empty($this->service))
            $this->load();

        return (bool) (isset($this->service[$name]) ? $this->service[$name]['visible'] : true);
    }

    public function serviceName($name){
        if (empty($this->service))
            $this->load();
        if (isset($this->service[$name])){
            if (trim($this->service[$name]['alias']))
                return $this->service[$name]['alias'];
            else
                return $this->service[$name]['name'];
        }
        else return false;
            


    }

    /**
     * Обновление 
     */
    public function mass_update(){
        $list = $_GET['services'];
        if (!empty($list)) foreach ($list as $item=>$vis) {
            $this->db->update(self::$table,array('visible'=>$vis ? 1 : 0),array('service'=>$item));
        }
    }

    public function chvis(){
        if ($this->_id)
            return $this->db->query('UPDATE :table SET `visible`=IF(`visible`,0,1) WHERE `service`=:service',array('table'=>db_name(self::$table),'service'=>$this->_id));

    }

    public function update() {
        if ($this->_id){
            $update = array('alias'=>clearUserText($_POST['alias']));
            return $this->db->update(self::$table,$update,array('service'=>$this->_id));
            //return $this->db->query('UPDATE :table SET visible=IF(visible,0,1) WHERE service=:service',array('table'=>db_name(self::$table),'service'=>$service));
        }
    }
}
?>