<?php

/**
 *  
 */
class account_forum extends Module {

    /**
     *   
     * @var string - db name
     */
    static $table = 'account_forum';

    public function load() {
        if ($this->id)
        return $this->db->query('SELECT DISTINCT `forum` . * , CONCAT_WS( " ", `user`.`name` , `user`.`patronim` , `user`.`family` ) AS `author`
            FROM `'.self::$table.'` AS `forum`
            LEFT JOIN `'.account::$table.'` AS `user` ON `user`.`id` = `forum`.`author_id`
            WHERE (`forum`.`show_in` =:id OR `forum`.`show_in`=0)
            ORDER BY `forum`.`last_reply` DESC',array('id'=>$this->id),db::FETCH_ALL);
    }

    public function load_full(){
        return $this->db->query('SELECT DISTINCT `forum` . * , CONCAT_WS( " ", `user`.`name` , `user`.`patronim` , `user`.`family` ) AS `author`
            FROM `'.self::$table.'` AS `forum`
            LEFT JOIN `'.account::$table.'` AS `user` ON `user`.`id` = `forum`.`author_id`
            ORDER BY `forum`.`last_reply` DESC',array(),db::FETCH_ALL);
    }


    public function load_by_authors($authors_array = array()){
        return $this->db->query('SELECT DISTINCT `forum` . * , CONCAT_WS( " ", `user`.`name` , `user`.`patronim` , `user`.`family` ) AS `author`
            FROM `'.self::$table.'` AS `forum`
            LEFT JOIN `'.account::$table.'` AS `user` ON `user`.`id` = `forum`.`author_id`
            WHERE `forum`.`author_id` IN ('.implode(', ',$authors_array).')
            ORDER BY `forum`.`last_reply` DESC',array(),db::FETCH_ALL);
    }

    public function load_by_id($id) {
        if ($this->id)
        return $this->db->query('SELECT DISTINCT `forum` . * , CONCAT_WS( " ", `user`.`name` , `user`.`patronim` , `user`.`family` ) AS `author`
            FROM `'.self::$table.'` AS `forum`
            LEFT JOIN `'.account::$table.'` AS `user` ON `user`.`id` = `forum`.`author_id`
            WHERE `forum`.`id` =:id
            ORDER BY `forum`.`last_reply` DESC',array('id'=>$id),db::FETCH_ROW);
    }

    public function create(array $options) {
        $options = $this->get_request(self::$table, $options);
        $options['last_reply'] = mktime();
        $options['create_date'] = mktime();
        parent::_create(self::$table, $options);
    }

    public function delete($id = null) {
        if (!$id)
            $id = $this->id;
        $this->_delete(self::$table, $id);
    }

    public function get_creator($theme_id){
        return $this->db->query('SELECT `author_id` FROM `'.self::$table.'` WHERE `id`=:id',array('id'=>$theme_id),db::FETCH_RESULT);
    }
    public function get_show_in_user($theme_id){
        return $this->db->query('SELECT 
            CONCAT_WS(" ",`account`.`name`,`account`.`patronim`,`account`.`family`) as `name`,
            `account`.`email`, `account`.`id` FROM :account_table
            LEFT JOIN :self_table as `forum` ON `forum`.`show_in`=`account`.`id`
            WHERE `forum`.`id` = :forum_id',
            array('account_table' => new db_name(account::$table), 'self_table' => new db_name(self::$table),
            'forum_id' => $theme_id), db::FETCH_ROW);
    }

    public function close($id) {
        return $this->db->query('UPDATE `' . self::$table . '` SET `status`=IF(`status`=1,2,1) WHERE `id`=' . $id);
    }

    public function update($id,$options){
        $options['last_update'] = date('Y-m-d H:i:s');
        parent::_update(self::$table, $id, $options);
    }
}
?>