<?php

/**
 *     s
 */
class account_messages extends Module {

    /**
     *   
     * @var string - db name
     */
    public static $table = 'account_message';

    /**
     *      ()
     * @var string - db name
     */
    public static $linkTable = 'account_document_message';

    //300   
    static $update_time = 300; 

    //  ;
    static $last_comments = 3;

    public function load_all() {
        return parent::_load_all(self::$table);
    }

    public function load() {
        if ($this->id !== null) {
            if (($row = $this->_load(self::$table, $this->id))) {
                $this->current = $row;
                return $row;
            }
        }
        return false;
    }

    /**
     *  c
     * @param array $options 
     */
    public function update($id, array $options = null) {
        if (!$options)
            $options = $this->get_request(self::$table, $options);
        parent::_update(self::$table, $id, $options);
    }

    public function create(array $options = null) {
        $options = $this->get_request(self::$table, $options);
        parent::_create(self::$table, $options);
        return $this->id;

    }

    /**
     *    id
     * @param int $id 
     */
    public function delete($id) {
            $this->_delete(self::$table, $id);
    }

    /**
     *    
     * @param int $id 
     */
    public function delete_messages_from_user($user_id){
        $this->db->query('DELETE FROM `'.self::$table.'` WHERE `user_ud`='.$id);
    }

    /**
     *    
     * @param int $id 
     */
    public function delete_messages_from_object($object_id){
        $this->db->query('DELETE FROM `'.self::$table.'` WHERE `object_id`='.$object_id);
    }

    /**
     *    
     * @param int $object_id 
     * @param string $option -   
     *          all (default) -   
     *          last -    (-: self::$last_comments)
     *          without_last - ,   (-: self::$last_comments)
     */
    public function load_messages_for_object($object_type,$object_id,$option = 'all',$count = 0){
        $limit = '';
        if (!$count) 
            $count = $this->load_messages_count($object_type,$object_id);
        if ($option != 'all' && $count){
                  if ($count>self::$last_comments){
                switch($option){
                    case 'last':
                        $limit = ' LIMIT '.($count-self::$last_comments).', '.self::$last_comments.' ';
                    break;
                    case 'without_last':
                        $limit = ' LIMIT 0, '.($count-self::$last_comments).' ';
                    break;
                }
            }
        }
        return $this->db->query('SELECT `message`.*,CONCAT_WS(" ",`user`.`name`,`user`.`patronim`,`user`.`family`) as `user_name`,`user`.`role` as `user_role`
                                 FROM `'.self::$table.'` as `message`
                                 LEFT JOIN `'.account::$table.'` as `user`
                                   ON `message`.`user_id` = `user`.`id`
                                 WHERE `message`.`object_type`=:type and `message`.`object_id`=:id
                                 '.$limit.' ',array('type'=>$object_type,'id'=>$object_id),db::FETCH_ALL);
    }

    public function load_messages_count($object_type,$object_id){
        return $this->db->query('SELECT COUNT(*) FROM :table WHERE `object_type`=:object_type AND `object_id`=:object_id',array('table'=>new db_name(self::$table), 'object_type'=>$object_type , 'object_id'=>$object_id ),db::FETCH_RESULT);
    }

    /**
     *    
     * @param int $message_id - id 
     * @param int $document_id - id  
     */
    public function attach_document($message_id,$document_id){
        parent::_create(self::$linkTable,array('message_id'=>$message_id, 'document_id'=>$document_id));
    }

    /**
     *    
     * @param int $id - id 
     */
    public function unattach_document($id){
        parent::delete(self::$table,$id);
    }
    /**
     *      
     * @param int $message_id - id 
     */
    public function get_attached_documents($message_id){
        return $this->db->query('
        SELECT 
            `link`.`document_id`,
            `message`.`user_id`,
            `doc`.`alias`,
            `doc`.`name`,
            `doc`.`size` 
        FROM `'.self::$linkTable.'` AS `link` 
        LEFT JOIN 
            `'.self::$table.'` AS `message` 
                ON `link`.`message_id` = `message`.`id`
        LEFT JOIN 
            `'.account_documents::$tableFiles.'` AS `doc` 
                ON `link`.`document_id` = `doc`.`file_id`
        WHERE `link`.`message_id` = :message_id',
            array('message_id' => $message_id),db::FETCH_ALL);
    }

    public function update_last_reply($table,$object_id){
        return $this->db->query('UPDATE :table SET `last_reply`=:time WHERE `id`=:id',
        array('table'=> new db_name($table), 'time'=>mktime(), 'id'=>$object_id));
    }
}

?>