<?php

/**
 *     
 *   class.account
 */
class Cart_logs extends Module {

    /**
     *   
     * @var string - db name
     */
    public static $table = 'cart_logs';

    public function load(){
        return $this->db->query('SELECT * FROM :table',array('table'=>new db_name(self::$table)),db::FETCH_ALL);
    }

    /**
     *    
     * @var int orderId - id 
     * @var varchar status_name -   ( id,     )
     * @var text message -   
     */
    public function setLog($orderId,$statusName,$userId,$message = '',$user_name = ''){
        $insert = array(
            'order_id' => $orderId,
            'status_name' => $statusName,
            'message' => $message,
            'date' => db_expr('NOW()'),
            'user_id' => $userId
        );
        if($user_name)
            $insert['user_name'] = $user_name;
        $this->db->insert(self::$table,$insert);
    }

    /**
     *      
     * @var int orderId - id 
     */
    public function getLogs($orderId){
        return $this->db->query(
            'SELECT `logs`.*, CONCAT_WS(" ",`account`.`name`,`account`.`patronim`,`account`.`family`) as `user` 
            FROM :log_table as `logs`
            LEFT JOIN :account_table as `account` ON `logs`.`user_id` = `account`.`id`
            WHERE `logs`.`order_id` = :order_id
            ORDER BY `id`',
            array( 'log_table'=>db_name(self::$table),'account_table'=>db_name(account::$table), 'order_id'=>$orderId),
            db::FETCH_ALL
            );
    }

    /**
     *   
     * @var int logId - id 
     */
    public function getLog($logId){
        return $this->db->query(
            'SELECT `logs`.*, CONCAT_WS(" ",`account`.`name`,`account`.`patronim`,`account`.`family`) as `user` 
            FROM :log_table as `logs`
            LEFT JOIN :account_table ON `logs`.`user_id` = `account`.`id`
            WHERE `logs`.`id` = :logId',
            array( 'log_table'=>db_name(self::$table),'account_table'=>db_name(account::$table), 'logId'=>$logId),
            db::FETCH_RESULT
        );
    }

    /**
     *  
     * @var int logId - id 
     */
    public function deleteLog($logId){
         return $this->db->delete(self::$table,array('id'=>$logId));
    }

}

?>