<?php
/**
 *  
 *
 * @author  
 */
class cart extends Module{

    /**
     *  
     * @var text
     */
    static $table = 'cart';

    /**
     *   
     * @var text
     */
    private static $table_session = 'cart_sessions';

    /**
     *   
     * @var text
     */
    private static $table_status = 'cart_statuses';

    /**
     *   
     * @var type 
     */
    public static $addCartUrl = '/cart/';

    /**
     *      
     */
    public static $on_page = 30;

    /**
     * 
     * @var array 
     */
    protected $cart_list = array();

    public static $status_img_path = 'content/user_files/status/';

     /**
      *  .
      *       ,      
      *  
      */
    protected $required_params = array('id','count', 'name'); //'price' 

     /**
      * @var int -     
      */
    protected $status_delete = 5;

    function __construct($db) {
        parent::__construct();
        if (!session_id()){
            session_start();
        }
        if (isset($_COOKIE['cart_sid'])){
            $_sess = $db->getOne(
                self::$table_session,
                'data',
                array(
                    'session_id' => $_COOKIE['cart_sid']
                )
            );
            if ($_sess)
                $this->cart_list = unserialize($_sess);
            else
                $this->cart_list = array();
        }else{
            $this->cart_list = array();
        }
    }

    public function load(){
        return $this->getOrders();
    }
        public function deleteitem($key=null)
    {   

      unset($this->cart_list[$key]);
      $mass = serialize($this->cart_list);
      $q=$this->db->update(self::$table_session,array('data'=>$mass),array('session_id' => $_COOKIE['cart_sid']));
      return true;
    }

    /**
     * add/update 
     * @param array $data
     * @param boolean $replace -      ( )
     */
    public function set($data, $replace = false) {
        if (!isset($data['id']))
            return false;
        if ($this->item_exists($data['id'])) {
            $this->update($data, $replace);
        }
        else
            $this->add($data);
        $this->save();
    }

    /**
     *    
     * @param array $data 
     */
    public function add($data) {
        if (!$this->array_key_exists_full($this->required_params, array_filter($data))) {
            return false;
        }
        $this->cart_list[$data['id']] = $data;
    }

    /**
     *   
     * @param type $data 
     */
    public function update($data, $replace = false) {
        if ($replace != false)
          $data['count'] = ($data['count'] + $this->cart_list[$data['id']]['count']);
        // if ($data['count'] == 0){
          // unset($this->cart_list[$data['id']]);
        // }
        // else
          $this->cart_list[$data['id']] = array_merge($this->cart_list[$data['id']], $data);
    }

    /**
     *    
     * @param type $data
     */
    public function saveOrder($data) {
        $insert = array(
            'user_id' => $data['user_id'] ? $data['user_id'] : '',
            'user' => !empty($data['user']) ? serialize($data['user']) : '',
            'items' => serialize($data['items']),
            'summ' => $data['summ'],
            'items_num' => $data['items_num'],
            'last_update' => mktime(),
            'user_name' => $data['user']['name'],
            'payment' => $data['payment'] ? $data['payment'] : '',
            'delivery_type' => $data['delivery_type'] ? $data['delivery_type'] : ''
        );
        $this->db->insert(self::$table, $insert);
        $this->destroy();
        return $this->db->get_id();
    }

    /**
     *  
     * @param type $data
     */
    public function updateOrder($id,$data) {
        $update = array(
            'items' => $data['items'],
            'user' => $data['user'],
            'summ' => $data['summ'],
            'items_num' => $data['items_num'],
        );
        //if (isset($data['deadline']))
            $update['deadline'] = $data['deadline'];
            if ($data['last_update'])
                $update['last_update'] = mktime();
        

        $this->db->update(self::$table,$update,array('id'=>$id));
    }

    /**
     *      
     * @param $id array
     * @param $data post array
     */
    public function doUpdateOrder($id = null){
        if (!$id) $id = $_GET['id'];
        $order = $this->getOrderById($id);
            if (!$order) return;
        //  :
        $items = array();
        $total_items = 0;
        $total_price = 0;
        
        $goods = new goods($this->db);
        $goods->load();
        $old_order_items = unserialize($order['items']);
        $user=$this->fillUserArrayFromPost();
    

        //   
        if ($_POST['item']['new']){
        $new_id =$_POST['item']['new'];
            if ($new_id){
            $items[$new_id] = array(
                'price' => $goods->data[$new_id]['price'],
                'id'    => $new_id,
                'count' => (int)$_POST['count']['new'],
                'name'  => $goods->data[$new_id]['name'],
                );
                if ($goods->data[$new_id]['not_fixed'])
                    $items[$new_id]['unfixed_price'] = 1;
            unset($_POST['item']['new']);
            $total_price +=$goods->data[$new_id]['price'];
            }
        }
        foreach ($_POST['item'] as $item_id=>$item){
            if (!$item) continue;
            $items[$item] = array(
                //       
                'price' => $goods->data[$item]['price'] ? 
                            $goods->data[$item]['price'] : $old_order_items[$item]['price'],
                'id'    => (int)$item,
                'count' => $_POST['count'][$item_id],
                'name'  => $goods->data[$item]['name'] ? 
                            $goods->data[$item]['name'] : $old_order_items[$item]['name'],
                );
                
                if ($_POST['price'][$item_id])
                    $items[$item]['price'] = $_POST['price'][$item_id];
                
                if ($old_order_items[$item]['unfixed_price'] == 1){
                    $items[$item]['unfixed_price'] = 1;
                }
                elseif($goods->data[$item]['not_fixed']){
                    $items[$item]['unfixed_price'] = 1;
                }
                else{
                    $items[$item]['unfixed_price']=0;
                    unset($items[$item]['unfixed_price']);
                }
            $total_items +=$_POST['count'][$item_id];

            if ($items[$item]['unfixed_price'] == 1)
                $total_price +=$items[$item]['price'];
            else
                $total_price +=$items[$item]['price']* $_POST['count'][$item_id];
                //$total_price +=$goods->data[$item]['price'] * $_POST['count'][$item_id];
        }
        $update = array(
            'items'     =>serialize($items),
            'user'      =>serialize($user),
            'summ'      => $total_price,
            'items_num' => $total_items,
        );
        $this->updateOrder($id,$update);
    }

    /**
     *   
     * @return array
     */
    public function getOrders($order = '`last_reply` DESC, `id` DESC',$where = null) {
        $q = 'SELECT * FROM `' . self::$table . '`
        '.($where != null ? " WHERE $where " : '').'
        ORDER BY '.$order;
        return $this->db->resultAsArray($q);
    }


    /**
     *    
     * @return array
     */
    public function getOrdersByPage($order = '`last_reply` DESC, `id` DESC',$where = null, $page='0') {
        $start = $page ? (((int)$page)-1)*self::$on_page : 0;
        $q = 'SELECT * FROM `' . self::$table . '`
        '.($where != null ? " WHERE $where " : '').'
        ORDER BY '.$order.' LIMIT '.$start.', '.self::$on_page;
        return $this->db->resultAsArray($q);
    }

    /**
     *  ,  
     * @return array
     */
    public function getOrdersCount($order = '`last_reply` DESC, `id` DESC',$where = null) {
        $q = 'SELECT COUNT(1) FROM `' . self::$table . '`
        '.($where != null ? " WHERE $where " : '').'
        ORDER BY '.$order;
        return $this->db->query($q,null,db::FETCH_RESULT);
    }



    /**
     *    
     * @return array
     */
    public function getUnuserOrders() {
        $q = 'SELECT `cart`.*,`status`.`name` as `status_name`,`status`.`status_id`,`status`.`color` FROM :table as `cart` 
        LEFT JOIN :status_table as `status` ON `status`.`status_id` = `cart`.`status`
        WHERE `user_id`=0
        ORDER BY `last_reply` DESC, `id` DESC';
           return $this->db->query($q, array('table'=>new db_name(self::$table),'status_table'=>new db_name(self::$table_status ) ) ,db::FETCH_ALL);
    }

    /**
     *  
     * @return array
     */
    public function getOrderById($id) {
        $q = 'SELECT `cart`.*,`status`.`name` as `status_name`,`status`.`status_id`,`status`.`color` FROM :table as `cart` LEFT JOIN :status_table as `status`
        ON `status`.`status_id` = `cart`.`status`
        WHERE `id`=:id';
        return $this->db->query($q, array('table' => new db_name(self::$table), 'id' => $id , 'status_table'=> new db_name(self::$table_status)), db::FETCH_ROW);
    }

    /**
     *      
     */
    public function getUserByOrderId($id){
        return $this->db->query('SELECT 
            CONCAT_WS(" ",`account`.`name`,`account`.`patronim`,`account`.`family`) as `name`,
            `account`.`email`, `account`.`id` FROM :account_table
            LEFT JOIN :self_table as `order` ON `order`.`user_id`=`account`.`id`
            WHERE `order`.`id` = :order_id',
            array('account_table' => new db_name(account::$table), 'self_table' => new db_name(self::$table),
            'order_id' => $id), db::FETCH_ROW);
    }

    /**
     *    
     * @return array
     */
    public function getOrdersByUserId($id) {
        // WHERE `user_id`=:id ORDER BY `last_reply` DESC, `id` DESC
        $q = 'SELECT `cart`.*,`status`.`name` as `status_name`,`status`.`status_id`,`status`.`color`
        FROM :table as `cart`
        LEFT JOIN :status_table as `status`
        ON `status`.`status_id` = `cart`.`status`
        WHERE `user_id`=:id ORDER BY `id` DESC
        ';
        return $this->db->query($q, array('table' => new db_name(self::$table), 'id' => $id,
        'status_table'=> new db_name(self::$table_status)
        ), db::FETCH_ALL);
    }

    /**
     * @var int -   ,       
     */
    public function deleteOrderById($id = null){
        $val = $this->get_request(self::$table, $values);
        if ($val['id'])
            return $this->change_status($id,$this->status_delete);
    }

    /**
     * @var int -     
     */
    public function forceDeleteOrderById($id){
        return $this->db->delete(self::$table, array('id'=>$id));
    }

    public function deleteFromOrder($id = null,$item_id = null){
        if (!$id) $id = $_GET['id'];
        if (!$item_id) $item_id = $_GET['item_id'];
        $order = $this->getOrderById($id);
        if ($order){
            //   
            $items = unserialize($order['items']);
            if (array_key_exists($item_id,$items))
                unset($items[$item_id]);
                //   ,    
                if (!empty($items)){
                    $price = 0;
                    $total_items = 0;
                    foreach($items as $item){
                        $price +=$item['price']*$item['count'];
                        $total_items += $item['count'];
                    }
                    $update =array(
                            'items'     =>serialize($items),
                            'summ'      => $price,
                            'items_num' => $total_items
                            );
                    $this->updateOrder($id,$update);
                }
                //  ,  
                else {
                    $update =array(
                            'items'     => serialize(array()),
                            'summ'      => 0,
                            'items_num' => 0
                            );
                    $this->updateOrder($id,$update);
                    $this->deleteOrderById($id);
                }
        }
        die();
    }

    /**
     *  
     */
    public function destroy($db_delete=false) {
        if ($db_delete && $_COOKIE['cart_sid']){
            $this->db->delete(self::$table_session,array('session_id' => $_COOKIE['cart_sid']));
            $_COOKIE['cart_sid'] = '';
        }
        unset($_SESSION['cart']);
        $this->cart_list = array();
    }

    /**
     *    
     * @return int
     */
    public function total() {
        if (!is_array($this->cart_list) && !empty($this->cart_list)) return false;
        // var_dump($this->cart_list);die();
        $total = array_map(array($this, 'get_price'), $this->cart_list);
        return array_sum($total);
    }

    /**
     *    
     * @return int
     */
    public function total_items() {
        if (!is_array($this->cart_list) && !empty($this->cart_list)) return 0;
        $total = array_map(array($this, 'get_count'), $this->cart_list);
        return array_sum($total);
    }

    /**
     *   
     * @return array
     */
    public function get_cart() {
        return $this->cart_list;
    }

    /**
     *    
     * @param array $item
     * @return mixed int, float
     */
    function get_price($item) {
        if ($item['unfixed_price']){
          return ' - ';
          // return $item['unfixed_title'] * $item['count'];
        }
        return $item['price'] * $item['count'];
    }

    /**
     *   
     * @param array $item
     * @return mixed int, float
     */
    function get_count($item) {
        return $item['count'];
    }

    /**
     *      
     * @param type $id
     * @return type 
     */
    public function item_exists($id) {
        if (key_exists($id, $this->cart_list))
            return true;
        else
            return false;
    }

    public static function order_key_clear($id=null){
      if (isset($_GET['order_key_clear'])){
        global $_configs;
        var_dump($_configs);die();
      }
    }
    protected function save() {
        setcookie('cart_sid', session_id() , time()+3600*24*365*5, "/");
        $data = mysql_real_escape_string(serialize($this->cart_list));
        $q = 'INSERT INTO `'.self::$table_session.'` 
                    (`session_id`,`data`) 
            VALUES  ("'.session_id().'", "'.$data.'")
            ON DUPLICATE KEY UPDATE `data`="'.$data.'"';
        $this->db->query($q);
    }

    protected function array_key_exists_full($key, $array) {
        if (!is_array($key))
            return array_key_exists($key, $array);
        else {
            $found = true;
            foreach ($key as $k) {
                if (!array_key_exists($k, $array))
                    $found = false;
            }
        }
        return $found;
    }

    public function order_exists($id){
        $result = $this->db->query('SELECT 1 FROM `' . self::$table . '` WHERE `id` = :id', array(
        "id" => $id));
        return @mysql_result($result, 0, 0) == 1;
    }

    public function get_status($id){
        return $this->db->query('SELECT `name` FROM :table WHERE `status_id`=:id',array('table'=> new db_name(self::$table_status),'id'=>$id),db::FETCH_RESULT);
    }

    public function get_all_statuses(){
      $r = $this->db->query('SELECT * FROM `'.self::$table_status.'`');
      $data = array();
      $v = array();
      if ($r) while ($v = mysql_fetch_array($r)){
        $data[$v['status_id']] = $v;
      }else return false;
      return $data;
    }

    public function change_status($order_id=0,$status_id = 0){
        if ($order_id == 0 or $status_id==0){
            $order_id = (int)$_POST['id'];
            $status_id = (int)$_POST['status'];
        }
        $this->db->update(self::$table,array('status'=>$status_id,'last_update'=>mktime()),array('id'=>$order_id));
    }

    public function update_status($values = null){
        if ($_REQUEST['stat']){
            if (is_array($_REQUEST['stat'])){
                foreach($_REQUEST['stat'] as $id=>$status){
                    $array = array('name'=>$status['name'],'color'=>$status['color']);
                    $this->db->update(self::$table_status,$array,array('status_id'=>$id));
                }
            }
        }
        //  
        if ($_REQUEST['new']){
        }
    }

    public function delete_status($id){
        // 11 -    
        if ($id>11)
            $this->db->delete(self::$table_status,array('status_id'=>$id));
    }

    public function get_status_delete(){
        return $this->status_delete;
    }

    public function get_shop_status(){
        return $this->db->query('SELECT sum(summ) as profit, sum(items_num) as items,count(id) as count FROM :table',array('table'=>new db_name(self::$table)),db::FETCH_ROW);
    }

    //   :
    public static function roundPriceDecimal($item_price) {
      $nprice=$item_price/100;
      $price=ceil($nprice/10)*10;
      return $price;
    }
    public static function getOrderStatusName($status_id){
      if (!$status_id) return false;
      $qSel="SELECT `name` FROM `cart_statuses` WHERE `status_id` = '$status_id'";
      $rSel=mysql_query($qSel);
      if(mysql_num_rows($rSel)) return mysql_result($rSel,0,'name');
      else die("!     .<hr>qSel= $qSel");
    }
  
    function fillUserArrayFromPost(){
      $arrFillUserData=array( 
                  'name',
                  'phone',
                  'email',
                  'card',
                  'delivery_city',
                  'delivery_type',
                  'delivery_price',
                  'delevery_address',
                  'payment',
                  'order_comment',
                  'organization'
                  );
      foreach($arrFillUserData as $val) {
        $user[$val]=($_POST[$val])? $_POST[$val]:'&nbsp;';
        //echo "<div>(empty) user[$val] = ".$user[$val]."</div>";
      }
      return $user; 
    }

}

?>
