<?php

class Catalog {

    /**
     *   
     * @var string - db name
     */
    public static $table = 'catalog_sect';
    /**
     *      
     * @var string - prefix
     */
    public static $popPrefix = 's_';
    /**
     *      
     * @var string - prefix
     */
    public static $popMediumPrefix = 'm_';
    /**
     *      
     * @var string - prefix
     */
    public static $popWgtPrefix = 'w_';
    /**
     *        
     * @var string 
     */
    public static $uploadFolder = '/content/user_files/catalog/';
    /**
     * id 
     * @var int
     */
    public $id = null;
    /**
     *       (SELECT *).
     * @var array 
     */
    public $data = array();
    /**
     *      .
     * : 
     * array (
     *      [1] => array(2, 3, 4, 5),
     *      [2] => array(6, 7, 8, 9)
     *  )
     * @var array 
     */
    public $child_array = array();
    /**
     *      ,   id.    load
     * @var array 
     */
    public $current = array();
    /**
     *
     * @var array 
     */
    public $main_menu = array();
    /**
     *
     * @var array 
     */
    public $out_array = array();
    /**
     *
     * @var type 
     */
    public $settings = array();
    /**
     * 
     * @var db $db
     */
    public static $db;

    function __construct($db) {
        self::$db = $db;
        $settings = new settings($db);
        $this->settings = $settings->load('catalog');
    }

    /**
     *           
     * @return boolean
     */
    function load() {
        $this->data = array();
        $this->child_array = array();
        $this->main_menu = array();
        $this->current = array();
        $q = 'SELECT `a`.`id`,`a`.`pid`,`a`.`vis`,`a`.`pos`,`a`.`name`, `a`.`image`, `a`.`pre_content` FROM `' . self::$table .
                '` as `a` LEFT JOIN (SELECT `object_id`,1 as `isseo` FROM `' . seo::$table_name .
                '` WHERE `module`="catalog" AND `object_type`="main") as `b` ON `a`.`id`=`b`.`object_id`  ORDER BY `a`.`pos`, `a`.`id`';
        $r = self::$db->query($q);
        while ($row = mysql_fetch_assoc($r)) {
            $this->data[$row['id']] = $row;
            if ($row['pid'] == 0)
                $this->main_menu[$row['id']] = $row;
            $this->child_array[$row['pid']][] = $row['id'];
        }
        if ($this->id) {
            $q = 'SELECT * FROM `' . self::$table . '` WHERE `id`=' . $this->id;
            $r = self::$db->query($q);
            if ($row = mysql_fetch_assoc($r))
                $this->current = $row;
        }
        return true;
    }

    /**
     *  id  
     * @param int $id 
     */
    function setId($id) {
        $this->id = $id;
    }

    /**
     *  id  
     * @return int
     */
    function getId() {
        return $this->id ? $this->id : '';
    }

    /**
     *    
     * @param int $id
     * @return int 
     */
    function getPid($id=false) {
        $sql = 'SELECT `pid` FROM `' . self::$table . '` WHERE `id`=' . ($id ? $id : $this->id);
        $res = self::$db->query($sql);
        if ($res)
            return mysql_result($res, 0, 0);
    }

    /**
     *     
     * @param int $id
     * @param array $parents - pure
     * @return array 
     */
    function getParents($id=0, $parents=array()) {
        while ($id) {
            $sql = 'SELECT `pid`,`id` FROM `' . self::$table . '` WHERE `id`=' . ($id);
            $res = self::$db->query($sql);
            if ($res){
                $parents[] = @mysql_result($res, 0, 1);
                $id = @mysql_result($res, 0, 0);
            }
        }
        return $parents;
    }

    /**
     *      id
     * @param int $parentId
     * @return string
     */
    function getParentName($parentId) {
        $sql = 'SELECT `name` FROM `' . self::$table . '` WHERE `id`=' . ($parentId);
        $res = self::$db->query($sql);
        $parents[] = mysql_result($res, 0, 0);

        return $parents[0];
    }

    static function getNameById($id) {
        $sql = 'SELECT `name` FROM `' . self::$table . '` WHERE `id`=' . $id;
        $res = self::$db->resultAsArray($sql);
        if ($res) {
            $name = array_pop($res);
            return $name['name'];
        }
    }

    function getStatusString($id) {
        $parents = array_reverse($this->getParents($id));
        $r = array();
        if (empty($this->data))
            $this->load();
        foreach ($parents as $p) {
            $r[$p] = $this->data[$p];
            $r[$p]['uri'] = $this->getUriById($p);
        }
        $r[$id] = $this->data[$id];
        $r[$id]['uri'] = $this->getUriById($p);
        return $r;
    }

    /**
     *  
     * @param id $pid
     */
    function getCatalog($pid) {
        $sql = 'SELECT * FROM `' . self::$table . '` WHERE `pid`=' . $pid . '  ORDER BY `pos`';
        return self::$db->resultAsArray($sql);
    }

    function getCatalogById($id) {
        if (!is_numeric($id)) return false;
        $sql = 'SELECT `name`,`vis`,`id`,`pid` FROM `' . self::$table . '` WHERE `id`=' . $id;
        $r = self::$db->query($sql);
        if ($r)
            return self::$db->fetch($r);
    }

    /**
     *  /  
     * @return boolean
     */
    function editCatalog() {
        // true,  .  - 
        $name = clearUserText($_POST['name'], false);
        $uri = clearUri($_POST['uri']);
        $uriExists = $this->uriExists($uri);
        $content = clearUserText($_POST['content']);
        $pre_content = clearUserText($_POST['pre_content']);
        $pid = (int) $_POST['pid'];
        $pos = (int) $_POST['pos'];
        $on_main = (int) isset($_POST['on_main']);
        $char_id = (int) $_POST['char_id'];
        $data = array(
            "name" => $name,
            "content" => $content,
            "pre_content" => $pre_content,
            "pos" => $pos,
            "on_main" => $on_main,
            "name" => $name,
            "char_id" => $char_id
        );
        if ($this->id) {
            if (!$uriExists) {
                $data['uri'] = $uri;
            }
            self::$db->update(self::$table, $data, array("id" => $this->id));
        } elseif ($name) {
            $data['vis'] = 1;
            $data['pid'] = $pid;

            $inn = self::$db->insert(self::$table, $data);
            if ($inn) {
                $id = self::$db->get_id();
                if ($id!=0 || $id!='') $masid = array("id" => $id);
                self::$db->update(self::$table, array(
                    "uri" => $id,
                    "pos" => $id
                        ), array("id" => $id));
            }
        }
        if ($_FILES['photo']['name'])
            $this->uploadImage();
    }

    /**
     *    ,   
     * @param array $array
     */

function chpos() {
        $array = $_POST['change'];
        foreach ($array as $key=>$v) {
            $update = array(
                'name' => $v['name'],
                'pos' => $v['pos']
                );
            self::$db->update(self::$table,$update,array('id'=>$key));

//self::$db->query('UPDATE `' . self::$table . '` SET `pos`=' . (int) $v . ' WHERE `id`=' . $k);
        }
        return true;
    }
    /*function chpos() {
        $array = $_POST['pos'];
        foreach ($array as $k => $v) {
            self::$db->update(self::$table, array('pos' => (int) $v), array('id' => $k));
        }
        return true;
    }*/

    /**
     *
     *    id
     * @param int $id
     */
    function delete() {
        if (!$this->data) $this->load();
        if ($this->id){
            $del = array($this->id);
            if (!empty($this->child_array) && is_array($this->get_child($this->id))){
                $del = array_merge($del, $this->get_child($this->id));
            }
            if (!empty($del)){
            //      
            self::$db->query('DELETE FROM `'.goods::$table.'` WHERE `cid` IN ('.implode(', ', $del).')');
            //    
            self::$db->query('DELETE FROM `'.self::$table.'` WHERE `id` IN ('.implode(',',$del).')');
            }
               // return self::$db->delete(self::$table, array('id' => $this->id));
            }
    }

    function get_child($id){
        if (empty($this->child_array[$id])) return false;
        $out = array();
        foreach($this->child_array[$id] as $k=>$v){
            $out[] = $v;
            if (!empty($this->child_array[$v])){
                $out = array_merge($out,$this->get_child($v));
            }
        }
        return $out;
    }

    /**
     *
     *  /  
     * @param int $id
     */
    function chvis() {
        if ($this->id)
            return self::$db->query('UPDATE `' . self::$table . '` SET `vis`=IF(`vis`,0,1) WHERE `id`=' . $this->id);
    }

    /*  */
    public function showning($cid) {
        if (!$cid) return false;
        $result = self::$db->query('SELECT `vis` FROM `'.self::$table.'` WHERE `id`='.$cid);
            while ($row = mysql_fetch_assoc($result)) {
                $vis = $row['vis'];
            }
        if ($vis) return true; 
            else return false;

    }

    /**
     *  
     * @return string - image name 
     */
    function getImage($id=null) {
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($id ? $id : $this->id);
        return @array_pop(self::$db->resultAsArray($sql));
    }

    /**
     *  
     * @param int $id - catalog id
     * @return boolean
     */
    function deleteImage($id = null) {
        if ($id == null) {
            if ($this->id == null)
                return false;
            $id = $this->id;
        }
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($id);
        $img = @array_pop(self::$db->resultAsArray($sql));
        if (isset($img['image']))
            $img = $img['image'];
        @unlink($_SERVER['DOCUMENT_ROOT'] . self::$uploadFolder . $img);
        @unlink($_SERVER['DOCUMENT_ROOT'] . self::$uploadFolder . self::$popPrefix . $img);
        return self::$db->query('UPDATE `' . self::$table . '` SET `image`="" WHERE `id`=' . $id);
    }

    /**
     *     
     * @return boolean
     */
    function uploadImage() {
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop(self::$db->resultAsArray($sql));
        $img = stripslashes($img['image']);
        @unlink(SR . '/' . self::$uploadFolder . $img);
        @unlink(SR . '/' . self::$uploadFolder . self::$popPrefix . $img);
        @unlink(SR . '/' . self::$uploadFolder . self::$popMediumPrefix . $img);
        $name = get_name_to_file();
        $ext = $_FILES['photo']['name'];
        $ext = explode('.', $ext);
        $ext = array_pop($ext);
        $resize = new upload($_FILES['photo']['tmp_name']);
        if ($resize->uploaded) {
            $type = $_FILES['photo']['type'];
            $type = explode('/', $type);
            if ($type[0] != 'image') {
                continue;
            }
            $resize->file_new_name_body = $name;
            $resize->file_new_name_ext = $ext;
            $resize->process(SR . self::$uploadFolder);

            $config = Config::load()->catalog;
            $imgsize = getimagesize(SR . self::$uploadFolder . $name . '.' . $ext);

            // 
            $resize->file_new_name_body = self::$popPrefix . $name;
            $resize->file_new_name_ext = $ext;
            $resize->file_overwrite = true;
            $resize->image_resize = true;
            $resize->image_ratio_fill = true;
            $resize->image_x = $config->get('image_width', 100);
            $resize->image_y = $config->get('image_height', 100);
            $resize->image_ratio_x = $config->get('scale_width', false);
            $resize->image_ratio_y = $config->get('scale_height', false);
            $resize->process(SR . self::$uploadFolder);

            //     (190x190)
            $resize->file_new_name_body = self::$popWgtPrefix . $name;
            $resize->file_new_name_ext = $ext;
            $resize->file_overwrite = true;
            $resize->image_resize = true;
            $resize->image_ratio_fill = true;
            $resize->image_x = $config->get('w_image_width', 100);
            $resize->image_y = $config->get('w_image_height', 100);
            $resize->image_ratio_x = $config->get('scale_width', false);
            $resize->image_ratio_y = $config->get('scale_height', false);
            $resize->process(SR . self::$uploadFolder);


            // 
            $resize->file_new_name_body = self::$popMediumPrefix . $name;
            $resize->file_new_name_ext = $ext;
            $resize->file_overwrite = true;
            $resize->image_resize = true;
            $resize->image_ratio_fill = true;
            $resize->image_x = $config->get('m_image_width', 200);
            $resize->image_y = $config->get('m_image_height', 200);
            /*$resize->image_ratio_x = $config->get('scale_width', false);
            $resize->image_ratio_y = $config->get('scale_height', false);*/
            $resize->process(SR . self::$uploadFolder);
            if ($resize->error)
                echo $resize->error;
            return self::$db->query('UPDATE `' . self::$table . '` SET `image`="' . mysql_real_escape_string($name) . '.' . $ext . '" WHERE `id`=' . $this->id);
        }
    }

    /**
     *         
     * @param string $text
     * @return array
     */
    static function search($text) {
        $text = trim(stripslashes(strip_tags($text)));
        $text = explode(' ', $text);
        $or = array();
        $fields = array('name', 'content');
        foreach ($text as $sr) {
            foreach ($fields as $v) {
                $or[] = '`' . $v . '` LIKE \'%' . $sr . '%\'';
            }
        }
        $or = implode(' OR ', $or);
        $sql = 'SELECT * FROM `' . self::$table . '` WHERE (' . $or . ')';
        return self::$db->resultAsArray($sql);
    }

    /**
     *    uri (url)
     * @param string $uri - uri
     * @return boolean
     */
    function uriExists($uri) {
        $q = 'SELECT `uri` FROM `' . self::$table . '` WHERE `uri`="' . $uri . '"';
        $r = self::$db->query($q);
        return @mysql_result($r, 0, 0) ? true : false;
    }

    /**
     *  id    uri
     * @param string $uri
     * @return int 
     */
    static function getIdByUri($uri) {
        $q = 'SELECT `id` FROM `' . self::$table . '` WHERE `uri`="' . $uri . '"';
        $r = mysql_query($q);
        if ($r)
            return @mysql_result($r, 0, 0);
    }

    /**
     *  uri    id
     * @param int $id
     * @return string
     */
    static function getUriById($id) {
        $q = 'SELECT `uri` FROM `' . self::$table . '` WHERE `id`="' . $id . '"';
        $r = mysql_query($q);
        if ($r)
            return @mysql_result($r, 0, 0);
    }

    /**
     * set
     * @param int $lvl -  .
     * @param array $array  -  
     */
    public function setOuterSection($lvl, $array) {
        $this->out_array = $array;
    }

    /**
     * get
     * @return array
     */
    public function getOuterSection() {
        return $this->out_array;
    }

    /**
     *    
     * @param type $id 
     */
    public function checkVisible($id) {
        $parent = $this->getParents($id);
        $check = true;
        if ($parent)
            foreach ($parent as $v) {
                if (!$v) continue;
                $item = $this->getCatalogById($v);
                if ($item['vis'] == 0)
                    $check = false;
            }
        return $check;
    }

    public function get_goods_count($where=''){
        //catalog_goods
        if ($where){
            $where = 'WHERE '.$where;
        }
        $items = self::$db->query('SELECT count( * ) AS items, `cid` FROM :table_goods '.$where.' GROUP BY `cid`',array('table_goods'=>db_name(goods::$table)),db::FETCH_ALL);
        $count = array();
        if (!empty($items)){
            foreach($items as $item){
                $count[$item['cid']] = $item['items'];
            }
        }
        return $count;
    }

    /* : 
        1)       
        2)   
    */
    function get_tree(array $without = array(), $goods=null) {
        //     
        $catalog = self::$db->query(
            "SELECT id, pid, name FROM :table ORDER BY `pos` ASC, `id`", 
            array('table'=> db_name(self::$table)), 
            db::FETCH_ALL
        );
        if ($goods){ //   
            return meno_create_full_tree($catalog, $goods);  
        }else{
            return meno_create_tree($catalog, $without);
        }
    }

    function ajax_form_move() {
        load_lib('admin');
        $this->id = $_REQUEST['id'];
        $tree = $this->get_tree(array($this->id));
        echo meno_show_move_tree($tree, 
            meno_build_go(
                array('do' => 'move', 'id' => $this->id)
                , null, 'catalog', false,'pid')
            );
    }

    function move($to = null){
        $this->id = $_REQUEST['id'];
        if ($to === null)
            $to = (int) $_REQUEST['pid'];
        else
            $to = (int) $to;
        $pt = $this->getParents($to);
        if (in_array($this->id, $pt)) {
            echo 'ARRRRR...';
            exit;
            return false;
        }
        $q = 'UPDATE `' . self::$table . '` SET `pid`=' . $to . ' WHERE `id`=' . $this->id;
        self::$db->query($q);
        return true;
    }

    function get_on_main(){
        return self::$db->query('SELECT * FROM :table WHERE `on_main`',
        array('table'=>db_name(self::$table)),db::FETCH_ALL);
    }

    public function get_access_list($a, $parentId = 0) {
        $this->id = null;
        $parentId = (!is_numeric($parentId)) ? 0 : $parentId;
        //$this->loadByParentId($parentId);
        $data = $this->getCatalog($parentId);
        //$data = $this->data;
        $o = '';
        if($data){
            $o .= '<ul>';
            foreach($data as $k=>$v){
                $o .= '<li><input type="checkbox" name="access[catalog][item]['.$v['id'].']" value="1" '.($a['catalog']['item'][$v['id']]?'checked="checked"':'').' >'.$v['name'];
                $o .= $this->get_access_list($a, $v['id']);
                $o .= '</li>';
            }
            $o .= '</ul>';
        }
        return $o;
    }
    function mass_action(){
        switch($_REQUEST['action']){
            case 'hide':
                if (is_array($_REQUEST['item'])){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->update(
                            self::$table,
                            array('vis'=>0),
                            array('id'=>$item_id)
                            );
                    }
                }
            break;
            case 'show':
                if (is_array($_REQUEST['item'])){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->update(
                            self::$table,
                            array('vis'=>1),
                            array('id'=>$item_id)
                            );
                    }   
                }
            break;
            case 'delete':
                if (is_array($_REQUEST['item'])){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->delete(
                            self::$table,
                            array('id'=>$item_id)
                            );
                    }
                }
            case 'move':
                if (is_array($_REQUEST['item']) && $_REQUEST['catalog_id']){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->update(
                            self::$table,
                            array('pid'=>$_REQUEST['catalog_id']),
                            array('id'=>$item_id)
                            );
                    }
                }
            break;  
        }
    }
}

?>