<?php

class db_value {

    protected $_value;

    function get_value() {
        return $this->value;
    }

    function __construct($value) {
        $this->value = $value;
    }

}

class db_expr extends db_value {

    protected $_params;

    function get_params() {
        return $this->_params;
    }

    function __construct($value, array $params = array()) {
        parent::__construct($value);
        $this->_params = $params;
    }

}

class db_name extends db_value {

    protected $_value;

    function get_value() {
        return $this->value;
    }

    function __construct($value) {
        $this->value = $value;
    }

}

function db_name($name) { return new db_name($name); }

function db_expr($expr, array $params = array()) { return new db_expr($expr, $params); }

class db {
    public $settings = array();
    public $qa = array();
    public $error;
    private $con = null;
    private $count_query = 0;

    const FETCH_NONE = 0;
    const FETCH_ROW = 1;
    const FETCH_RESULT = 2;
    const FETCH_ALL = 3;

    public $table_columns = array();

    function __construct() {
        
    }

    function __destruct() {
        // echo '<!--' . $this->count_query . ' -->';
        //   
        $config = Config::load();
        if ($config->db->has_statistic) {
            $q = 'INSERT INTO `statistic` (`average`,`i`) VALUES (' . $this->count_query . ',1)';
            $this->query($q);
        }
    }

    function connect() {
        //   
        $config = Config::load();
        $host = $config->db->host;
        $user = $config->db->user;
        $password = $config->db->password;
        $db_name = $config->db->db_name;

        if (!$this->con = mysql_connect($host, $user, $password)) {
            $this->error = mysql_error();
            return false;
        }
        if (!mysql_select_db($db_name, $this->con)) {
            $this->error = mysql_error();
            return false;
        }
        $this->query('set names cp1251');
        return true;
    }
    public function getHandle(){
        return $this->con;
    }
    public function _stripslashes($value) {
        if (is_string($value))
            return stripslashes($value);
        return $value;
    }

    public function get_colums_from_table($table_name) {
        if (!isset($this->table_columns[$table_name])) {
            $result = $this->query("DESCRIBE `" . $table_name . '`');
            while ($row = mysql_fetch_assoc($result)) {
                $this->table_columns[$table_name][] = $row['Field'];
            }
        }
        
        return $this->table_columns[$table_name];
    }
    
    public function has_column_in_table($table_name, $column) {
        return in_array($column, $this->get_colums_from_table($table_name));
    }
    
    public function get_request_fill(array $values = null) {
        if ($values === null) {
            $values = $_REQUEST;
        }
        if (get_magic_quotes_gpc())
            $values = array_map(array($this, '_stripslashes'), $values);
        return $values;
    }
    
    public function get_request($table_name, array $values = null) {
        $values = $this->get_request_fill($values);
        $result = array();
        $columns = $this->get_colums_from_table($table_name);
        foreach ($values as $field => $value) {
            if (in_array($field, $columns))
                $result[$field] = $value;
        }
        return $result;
    }
    function justquery ($query ){
        return mysql_query($query);
    }
    function query($query, array $params = null, $fetch_mode = self::FETCH_NONE) {
        if ($params == null)
            $params = array();
        $original = $query;
        $query = $this->prepare($original, $params);
        // var_dump($query);echo '<br><br>';
        if ($query)
            try {
                $result = mysql_query($query);
                if (0 !== mysql_errno()) {
                    $config = Config::load();
                    if ($config->debug->display_error) {
                        var_dump($original);
                        throw new Exception(mysql_error(), mysql_errno());
                    }
                }
                $this->count_query++;
                switch ($fetch_mode) {
                    case self::FETCH_RESULT:
                        if ($result) {
                            return @mysql_result($result, 0, 0);
                        }
                        break;

                    case self::FETCH_ALL:
                        if ($result) {
                            $array = array();
                            while ($row = mysql_fetch_assoc($result))
                            {
                                $array[] = $row;
                            }
                            return $array;
                        }
                        break;

                    case self::FETCH_ROW:
                        if ($result && mysql_num_rows($result)) {
                            return mysql_fetch_assoc($result);
                        }
                        break;
                    default:
                        return $result;
                }
            } catch (Exception $e) {
                // die("Error!: " . $e->getMessage() . "<br/>");
                throw $e;
            }
        return false;
    }

    function get_id() {
        return mysql_insert_id($this->con);
    }

    function get($field, $module = 'main') {
        if (isset($this->settings[$module][$field]['value']))
            return $this->settings[$module][$field]['value'];
        return '';
    }

    public function fetch($value) {
        return mysql_fetch_assoc($value);
    }

    /**
     *
     * @param mysql $query
     * @return array 
     */
    public function resultAsArray($query) {
        $result = array();
        $res = $this->query($query);
        if (!$res)
            return false;
        while ($r = $this->fetch($res))
            $result[] = $r;
        return $result;
    }

    public function prepare($query, array $params = array()) {
        foreach ($params as $key => $value) {
            if (!empty($key)) {
                $key = ":" . (string) $key;
                $value = $this->escape($value);
                $query = str_replace($key, $value, $query);
            }
        }
        return $query;
    }

public function escape($value) {
    if (is_array($value)) {
            $result = array();
            foreach ($value as $part) {
                $result[] = $this->escape($part, false);
            }
            return implode(', ', $result);
        } elseif ($value instanceof db_expr) {
            return $this->prepare($value->get_value(), $value->get_params());
        } elseif ($value instanceof db_name) {
            return '`' . $value->get_value() . '`';
        } elseif ($value instanceof db_value) {
            $value = $value->get_value();
        }

        if (is_float($value)) {
            $value = str_replace(',', '.', $value);
            return $value;
        } elseif (is_integer($value)) {
            return $value;
        } elseif (is_object($value)) {
            return serialize($value);
        }
        return "'" . mysql_real_escape_string($value, $this->con) . "'";
    }

    function ifTableExists($tableName) {
        return $this->query("SELECT * FROM `$tableName` WHERE 1=0");
    }

    public function insert($table_name, array $row) {
        $columns_clause = '';
        $values_clause = '';

        foreach ($row as $key => $value) {
            if (!empty($key)) {
                $value = $this->escape($value);
                if ($columns_clause != '') {
                    $columns_clause .= ', ';
                    $values_clause  .= ', ';
                }
                $columns_clause .= "`$key`";
                $values_clause  .= $value;
            }
        }
        $query = "INSERT INTO `$table_name` ($columns_clause) VALUES ($values_clause)";
        $this->query($query);
        return mysql_affected_rows($this->con);
    }

    public function update($table_name, array $row, $where_clause) {
        $update_clause = '';
        foreach ($row as $key => $value) {
            if (!empty($key)) {
                $value = $this->escape($value);
                if ($update_clause != '')
                    $update_clause .= ', ';
                $update_clause .= "`$key` = $value";
            }
        }

        if (is_array($where_clause)) {
            $where_params = $where_clause;
            $where_clause = '';

            foreach ($where_params as $key => $value) {
                $value = $this->escape($value);
                if ($where_clause != '')
                    $where_clause .= ' AND ';
                $where_clause .= "`$key` = $value";
            }
        }

        if (empty($where_clause)) {
            throw new Exception("    !!!");
        }

        $query = "UPDATE `$table_name` SET $update_clause WHERE $where_clause";
        $this->query($query);
        return mysql_affected_rows($this->con);
    }

    public function delete($table_name, $where_clause) {
        if (is_array($where_clause)) {
            $where_params = $where_clause;
            $where_clause = '';

            foreach ($where_params as $key => $value) {
                $value = $this->escape($value);
                if ($where_clause != '')
                    $where_clause .= ' AND ';
                $where_clause .= "`$key` = $value";
            }
        }

        if (empty($where_clause)) {
            throw new Exception("    !!!");
        }

        $query = "DELETE FROM `$table_name` WHERE $where_clause";
        $this->query($query);
        return mysql_affected_rows($this->con);
    }

    public function replace($table_name, array $row, array $keys) {
        $columns_clause = '';
        $values_clause  = '';
        $update_clause  = '';

        $full = array_merge($row, $keys);
        foreach ($full as $key => $value) {
            if (!empty($key)) {
                $value = $this->escape($value);
                if ($columns_clause != '') {
                    $columns_clause .= ', ';
                    $values_clause .= ', ';
                }
                $columns_clause .= "`$key`";
                $values_clause .= $value;
            }
        }

        foreach ($row as $key => $value) {
            if (!empty($key)) {
                $value = $this->escape($value);
                if ($update_clause != '')
                    $update_clause .= ', ';
                $update_clause .= "`$key` = $value";
            }
        }

        $query = 'INSERT INTO ' . $table_name . ' (' . $columns_clause . ') VALUES (' . $values_clause . ') ON DUPLICATE KEY UPDATE ' . $update_clause;
        // var_dump($query);die();
        $this->query($query);
        return mysql_affected_rows($this->con);
    }

    public function getOne($table_name, $param, $where_clause) {
        if (is_array($where_clause)) {
            $where_params = $where_clause;
            $where_clause = '';

            foreach ($where_params as $key => $value) {
                $value = $this->escape($value);
                if ($where_clause != '')
                    $where_clause .= ' AND ';
                $where_clause .= "`$key` = $value";
            }
        }
        $query = 'SELECT `' . $param . '` FROM `' . $table_name . '` WHERE ' . $where_clause . ' LIMIT 1';
        $res = $this->query($query);
        if ($res)
            return @mysql_result($res, 0, 0);
        else
            return false;
    }

    public function commit() {
        return $this->query("COMMIT", null, self::FETCH_RESULT);
    }

    public function rollback() {
        return $this->query("ROLLBACK", null, self::FETCH_RESULT);
    }

    public function begin() {
        return $this->query("BEGIN", null, self::FETCH_RESULT);
    }

    public function getTableContent($table,$where=false,$order_by=false,$fields=false){
        if (!$fields) {
            $fields=' * ';
            $arrFields=array();
        }
        if ($where) $where="WHERE $where";
        //   :
        else $arrFields=explode(",",$fields);
        $arrFields=array();
        $sql="SELECT $fields FROM $table $where"; 
        if ($order_by) $sql.=" ORDER BY $order_by"; //echo "<div>sql= $sql</div>";
        $r=mysql_query($sql); 
        if (mysql_error()) {
            if (mysql_errno()==1064) echo "<h5>  :</h5><pre>$sql</pre><hr>";
            die("# : ".mysql_errno()."<hr>".mysql_error()."<hr>: ".$sql);
        }
        $i=0;
        while ($arr = mysql_fetch_assoc($r)) { 
            foreach ($arr as $key=>$val) {
                $arrFields[$i][$key]=$val;
                //echo "<br>key=[$key] => $val</br>";
            }//echo "<hr>";
            $arrFields[$key];
            $i++;
        }
        return $arrFields;
    }
    
}

?>