<?php

class infosection extends module {

    public static $table_name = 'infosection';
    public $id = null;
    public $data = array();
    public $child_array = array();
    public $curent = array();
    public $settings = array();
    public $main_menu = array();
    public $db;
    public $user;

    function __construct($db, $id = null) {
        $this->db = $db;
        $this->user = @$_SESSION['user'];
        $settings = new settings($db);
        $this->settings = $settings->load('infosection');
        unset($settings);
        if ($id === null)
            $this->id = (int) @$_REQUEST['id'];
        else
            $this->id = (int) $id;
    }

    function setId($id) {
        $this->id = $id;
    }

    function load_by_uri($uri, $pid = null) {
        if ($uri != clearUri($uri) && trim($uri) == '') {
            $this->current == false;
        } elseif ($pid) {
            $this->current = $this->db->query('SELECT * FROM :table WHERE uri = :uri AND pid = :pid', array(
                'table' => db_name(self::$table_name),
                'uri' => $uri,
                'pid' => $pid
                    ), db::FETCH_ROW);
        } else {
            $this->current = $this->db->query('SELECT * FROM :table WHERE uri = :uri AND (pid = 0 or pid IS NULL or pid = 1) ORDER BY pid DESC', array(
                'table' => db_name(self::$table_name),
                'uri' => $uri
                    ), db::FETCH_ROW);
        }

        if ($this->current) {
            $this->id = $this->current['id'];
        } else {
            $this->id = false;
        }
        return $this->current;
    }

    function load() {
        $this->data = array();
        $this->child_array = array();
        $this->main_menu = array();
        $this->curent = array();
        $q = 'SELECT `a`.`id`,`a`.`pid`,`a`.`menu_text`, `a`.`is-sub`, `a`.`uri`,`a`.`visible`,`a`.`sort`,`a`.`name`,`b`.`isseo` FROM `' . self::$table_name .
                '` as `a` LEFT JOIN (SELECT `object_id`,1 as `isseo` FROM `' . seo::$table_name .
                '` WHERE `module`="infosection" AND `object_type`="main") as `b` ON `a`.`id`=`b`.`object_id`  ORDER BY  `a`.`sort` ASC, `a`.`id`';
        $r = $this->db->query($q);
        while ($row = mysql_fetch_assoc($r)) {
            $this->data[$row['id']] = $row;
            if ($row['pid'] == 0)
                $this->main_menu[$row['id']] = $row;
            $this->child_array[$row['pid']][] = $row['id'];
        }
        if ($this->id) {
            $q = 'SELECT * FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
            $r = $this->db->query($q);
            if ($row = mysql_fetch_assoc($r))
                $this->curent = $row;
        }
        return true;
    }

    function loadByParentId($parentId = 0) {
        // $this->data = array();
        // $this->child_array = array();
        $this->curent = array();
        $q = 'SELECT `a`.`id`,`a`.`pid`,`a`.`uri`,`a`.`visible`,`a`.`sort`,`a`.`name`,`b`.`isseo` FROM `' . self::$table_name .
                '` as `a` LEFT JOIN (SELECT `object_id`,1 as `isseo` FROM `' . seo::$table_name .
                '` WHERE `module`="infosection" AND `object_type`="main") as `b` ON `a`.`id`=`b`.`object_id` WHERE `a`.`pid` = ' . $parentId . '  ORDER BY `a`.`sort` ASC, `a`.`id`';
        $r = $this->db->query($q);
        while ($row = mysql_fetch_assoc($r)) {
            $this->data[$row['id']] = $row;
            $this->child_array[$row['pid']][] = $row['id'];
        }
        return true;
    }

    function create($options = null) {
        $this->load();
        if ((int) $this->settings['first_level_fixed']['value'] && $this->id == 0)
            return false;
        $branch = $this->get_parrent_array($this->id);
        $ch = array();
        if (isset($this->settings['child_allowed']['value']) && $this->settings['child_allowed']['value'])
            $ch = explode(',', $this->settings['child_allowed']['value']);
        if ($this->settings['max_level']['value'] && (count($branch) > (int) $this->settings['max_level']['value']) and !in_array($this->id, $ch))
            return false;
        $array = $this->get_request(self::$table_name,$options);
        if (self::_create(self::$table_name, $array) == false)
            return false;

        $subgallery = new subgallery($this->db);
        $subgallery->load_size_for_module('infosection');
        $subgallery->add($this->id, 'infosection');
        return true;
    }

    function update($options = null) {
        if ($this->current == false || $this->current == null) {
            $this->load();
        }
        $options = $this->get_request(self::$table_name, $options);
        foreach (array('is-sub', 'hide-title') as $key) {
            $options[$key] = isset($options[$key]) ? $options[$key] == 'on' : false;
        }

        if (isset($options['uri'])) {
            $options['uri'] = clearUri(trim(strip_tags($options['uri'])));
            $clone = clone $this;
            if (false != $clone->load_by_uri($options['uri'], $this->current['pid'])) {
                unset($options['uri']);
            }
        }

        $options = $this->get_request(self::$table_name, $options);
        $this->_update(self::$table_name, $this->id, $options);

        $subgallery = new subgallery($this->db);
        $subgallery->load_size_for_module('infosection');
        $subgallery->add($this->id, 'infosection');
    }

    function delete() {
        $this->load();
        if (!$this->id)
            return false;
        if ((int) $this->settings['first_level_fixed']['value'] && $this->data[$this->id]['pid'] == 0)
            return false;
        $subgallery = new subgallery($this->db);
        if (!$subgallery->clear_object($this->id, 'infosection'))
            return false;
        $q = 'SELECT `id` FROM `' . self::$table_name . '` WHERE `pid`=' . $this->id;
        $r = $this->db->query($q);
        $subsection = new infosection($this->db, 0);
        while ($row = mysql_fetch_assoc($r)) {
            $subsection->id = $row['id'];
            $subsection->delete();
        }
        $q = 'DELETE FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    function hide() {
        if (!$this->id)
            return false;
        $q = 'UPDATE `' . self::$table_name . '` SET `visible`=0 WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    function show() {
        if (!$this->id)
            return false;
        $q = 'UPDATE `' . self::$table_name . '` SET `visible`=1 WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    function move($to = null) {
        if ($to === null)
            $to = (int) $_REQUEST['pid'];
        else
            $to = (int) $to;
        $pt = $this->get_parrent_array($to);
        if (in_array($this->id, $pt)) {
            echo 'ROOR';
            exit;
            return false;
        }
        $q = 'UPDATE `' . self::$table_name . '` SET `pid`=' . $to . ' WHERE `id`=' . $this->id;
        $this->db->query($q);
        return true;
    }

    function get_cannon_url($id = null) {
        $id = $id == null ? $this->id : $id;
        if ($id == 1) {
            $cannon_url = '/';
        } else {
            $cannon_url = '/section/' . $id . '/';
            $anonce_url = null;
            foreach ($this->get_parrent_array($id) as $pid) {
                if ($pid == 0)
                    break;
                if ($this->data[$pid]['uri']) {
                    $anonce_url = '/' . $this->data[$pid]['uri'] . $anonce_url;
                } else {
                    $anonce_url = null;
                    break;
                }
            }

            if ($anonce_url) {
                $cannon_url = $anonce_url;
            }
        }
        return rtrim($cannon_url, '/').'/';
        // return meno_full_url($cannon_url);
    }

    function get_parrent_array($id) {
        $id = (int) $id;
        $o = array();
        while ($id) {
            $o[] = $id;
            $id = $this->data[$id]['pid'];
        }
        $o[] = 0;
        return $o;
    }

    function save_settings() {
        if ($this->user->root) {
            $settings = new settings($this->db);
            $settings->save(null, 'infosection');
            if ($_REQUEST['field']) {
                $a = array_map('stripslashes', $_REQUEST);
                $settings->create($a['field'], $a['name'], $a['value'], 'infosection');
            }
        }
    }

    public function get_access_list($a, $parentId = 0) {
        $this->id = null;

        $parentId = (!is_numeric($parentId)) ? 0 : $parentId;

        $this->loadByParentId($parentId);
        $data = array();
        if (!empty($this->child_array[$parentId])) {
            foreach ($this->child_array[$parentId] as $id) {
                $data[$id] = $this->data[$id];
            }
        }
        $o = '';

        if ($data) {
            $o .= '<ul>';
            foreach ($data as $k => $v) {
                $o .= '<li><input type="checkbox" name="access[infosection][item][' . $k . ']" value="1" ' . ($a['infosection']['item'][$k] ? 'checked="checked"' : '') . ' >' . $v['name'];
                $o .= $this->get_access_list($a, $k);
                $o .= '</li>';
            }
            $o .= '</ul>';
        }
        return $o;
    }

    function get_tree(array $without = array()) {
        $result = $this->db->query("SELECT id, pid, name FROM :table ORDER BY `sort` ASC, `id`", array(
            'table' => db_name(self::$table_name)
                ), db::FETCH_ALL);

        return meno_create_tree($result, $without);
    }

    function ajax_form_move() {
        load_lib('admin');
        $tree = $this->get_tree(array($this->id));
        echo meno_show_move_tree($tree, meno_build_go(array('do' => 'move', 'id' => $this->id), null, 'infosection', false));
    }

}

?>