<?php

/**
 * @improved by Arbora Sergey (http://arbora.ru)
 *
 * Класс для возможности скрытия/отображения сервисов на сайте
 * Пока сервисы берутся из базы и не редактируются.
 * в будующем продумать общую схему добавления/удаления сервисов из списка.
 *
 */

class loader extends Module{

    public static $table = 'load_service';


    public $service = array();
    public $child_array = array();
    public $data = array();

    private $_id;

    public function setId($id){
        $this->_id = $id;
    }
    
    function load(){
        $_data = $this->db->query('SELECT * FROM :table ORDER BY `name`',array('table'=>db_name(self::$table)),db::FETCH_ALL);
        if (!empty($_data)) foreach ($_data as $item) {
            $this->child_array[$item['pid']][]  = $item['id'];
            $this->data[$item['id']]            = $item;
            // if (!$item['pid']){
                $this->service[$item['service']]    = $item;
            // }
        }
        
        
        // var_dump($this->child_array);die();

        // foreach ($this->data as $id => $item) {
        //     if ($item['pid']){
        //         $this->service[$item['service']]    = $item;
        //     }
        // }
        // var_dump($this->service);die();
        return $this->service;
    }

    /**
     * Проверка на активность сервиса. 
     * возарвщвет false в случае если сервис не активен, но существует.
     * true при любых других резултатах (нет в саписке или активен)
     * Делаю костыльно, тупо проверка 3-х уровней, т.к. времени нет проектировать
     * @param string $name
     */
    public function serviceActive(){
        if (empty($this->service))
            $this->load();
        $args = func_get_args();
        if (!$args)
            return false;
        $IDS = array();
        // Берем первый и по-порядку
        if (!$this->service[$args[0]])
            return true;
        $IDS[] = $this->service[$args[0]]['id'];
        $first = $this->service[$args[0]];
        // Проверяем второй
        if ($args[1] && $this->child_array[$first['id']]){
            $second = 0;
            foreach ($this->child_array[$first['id']] as $id) {
                if($this->data[$id]['service'] == $args[1]){
                    $second = $this->data[$id];
                    break;
                }
            }
            if ($second){ $IDS[] = $second['id']; }
        }
        if ($args[2] && $this->child_array[$second['id']]){
            $third = 0;
            foreach ($this->child_array[$second['id']] as $id) {
                if($this->data[$id]['service'] == $args[2]){
                    $third = $this->data[$id];
                    break;
                }
            }
            if ($third){ $IDS[] = $third['id']; }
        }
        foreach ($IDS as $id) {
            
            if (!$this->data[$id]['active'] || !$this->data[$id]['visible']){
                return false;
            }
        }
        return true;
    }

    public function serviceActiveMeno(){
        if (empty($this->service))
            $this->load();
        $args = func_get_args();
        if (!$args)
            return false;
        $IDS = array();
        // Берем первый и по-порядку
        if (!$this->service[$args[0]])
            return true;
        $IDS[] = $this->service[$args[0]]['id'];
        $first = $this->service[$args[0]];
        // Проверяем второй
        if ($args[1] && $this->child_array[$first['id']]){
            $second = 0;
            foreach ($this->child_array[$first['id']] as $id) {
                if($this->data[$id]['service'] == $args[1]){
                    $second = $this->data[$id];
                    break;
                }
            }
            if ($second){ $IDS[] = $second['id']; }
        }
        if ($args[2] && $this->child_array[$second['id']]){
            $third = 0;
            foreach ($this->child_array[$second['id']] as $id) {
                if($this->data[$id]['service'] == $args[2]){
                    $third = $this->data[$id];
                    break;
                }
            }
            if ($third){ $IDS[] = $third['id']; }
        }
        foreach ($IDS as $id) {
            if (!$this->data[$id]['active']){
                return false;
            }
        }
        return true;
    }



    // public function ByPidAndName()

    public function serviceName($name){
        if (empty($this->service))
            $this->load();
        if (isset($this->service[$name])){
            if (trim($this->service[$name]['alias']))
                return $this->service[$name]['alias'];
            else
                return $this->service[$name]['name'];
        }
        else return false;
            


    }

    /**
     * Обновление 
     */
    public function mass_update(){
        $list = $_GET['services'];
        if (!empty($list)) foreach ($list as $item=>$vis) {
            $this->db->update(self::$table,array('visible'=>$vis ? 1 : 0),array('service'=>$item));
        }
    }

    public function chvis(){
        if ($this->_id)
            return $this->db->query(
                'UPDATE :table SET `visible`=IF(`visible`,0,1) WHERE `id`=:id',
                array(
                    'table'=>db_name(self::$table),
                    'id'=>$this->_id
                    )
                );
    }
    public function mass_activate(){
        if (!isset($_POST['active'])){
            return $this->db->query('UPDATE :table SET `active`=FALSE',
                array('table'=>db_name(self::$table))
            );
            return true;
        }
        $active = implode(',',
                    array_keys($_POST['active']));
        // var_dump($active);die();
        return $this->db->query(
            'UPDATE :table SET `active`=IF((`id` IN ('.$active.')),1,0)',
            array('table'=>db_name(self::$table))
            );
    }

    public function update() {
        if ($this->_id){
            $update = array('alias'=>clearUserText($_POST['alias']));
            return $this->db->update(self::$table,$update,array('service'=>$this->_id));
            //return $this->db->query('UPDATE :table SET visible=IF(visible,0,1) WHERE service=:service',array('table'=>db_name(self::$table),'service'=>$service));
        }
    }
}
?>