<?php




/**
 *     .
 * 
 * @author Arbora Sergey (http://arbora.ru)
 * @todo  
 *
 *    $config->email_templates  -   
 *   
 *  - name:  (  )
 *  - params:   
 *
 */

class mails extends module {
    public static $table           = 'mails';
    public static $table_translate = 'mails_translate';
    
    protected static $instance = null;
    protected $_queue   = array();
    protected $_enabled = false;

    public static function get_instance() {
        if (self::$instance == null) {
            self::$instance = new self();
        }
        return self::$instance;
    }

    public static function get_global_variables() {
        return  array(
            'site-name' => ' ',
            'site-link' => '  ',
            'site-url'  => '  '
        );
    }

    protected function _prepare($template) {
        $config = Config::load();

        $result = array();
        foreach ($template as $locale_row) {
            $result['id']    = $locale_row['id'];
            $result['alias'] = $locale_row['alias'];
            $alias           = $locale_row['alias'];

            $lang = $locale_row['lang'];
            if ($lang == null)
                continue;
            if ($locale_row['title'] == null)
                unset($locale_row['title']);

            $locale           = $config->email_templates[$alias]->toArray();
            
            $result[ $lang ]  = array_merge(array(
                'title'           => $locale['name'],
                'manager-receive' => true,
                'user-receive'    => true,
        
            ), $locale, $locale_row);
            $result = array_merge(array(
                'manager-receive' => true,
                'user-receive'    => true,
            ), $locale, $result);
        }
        if (!isset($config->email_templates[$result['alias']]))
            return null;
        $locale = $config->email_templates[$result['alias']]->toArray();
        $result = array_merge($locale, $result);
        $result['params'] = array_merge(@$result['params'], self::get_global_variables());
        foreach (meno_languages() as $lang => $name) {
            $locale['title'] = $locale['name'];
            $result[$lang]   = array_merge($locale, (array) $result[$lang]);
        }

            // var_dump($result);die();
        return $result;
    }

    public function load_by_alias($alias) {
        if ($alias == null)
            return null;
        	$template = $this->db->query(
            'SELECT *, m.id as id
                FROM `'.self::$table.'` AS m
                LEFT JOIN `'.self::$table_translate.'` as tm ON tm.id = m.id
                WHERE m.alias = "'.$alias.'"
            ',
            null, 
            db::FETCH_ALL
        );

        return $this->_prepare($template);
    }

    public function load() {
        if ($this->id) {
            $template = $this->db->query(
                'SELECT *, m.id as id
                    FROM `'.self::$table.'` AS m
                    LEFT JOIN `'.self::$table_translate.'` as tm ON tm.id = m.id
                    WHERE m.id = "'.$this->id.'"
                ',
                null, 
                db::FETCH_ALL
            );
            // var_dump($template);die();
            return $this->current = $this->_prepare($template);
        } else {
            $result = array();
            foreach ($this->_load_all(self::$table) as $template) {
                $template = $this->db->query(
                    'SELECT *, m.id as id
                        FROM `'.self::$table.'` AS m
                        LEFT JOIN `'.self::$table_translate.'` as tm ON tm.id = m.id
                        WHERE m.id = "'.$template['id'].'"
                    ',
                     null,
                    db::FETCH_ALL
                );
                $template = $this->_prepare($template);
                $result[$template['alias']] = $template;
            }
            $result = array_filter($result);

            ///   
            $reload = false;
            $resultTemp = $result;
            $config = Config::load();
            foreach ($config->email_templates as $alias => $value) {
                $template = array();
                foreach (meno_languages() as $lang => $name) {
                    $template[$lang] = $value->toArray();
                }
                $template = $this->_prepare($template);
                if (!isset($resultTemp[$alias]) && null == $resultTemp[$alias]['id']) {
                    $id     = $this->_insert(self::$table, array('alias' => $alias));
                    $reload = true;
                    $result = null;
                }
            }
            ///    
            $this->id = null;
            if ($reload)
                return $this->load();
            return $this->data = $result;
        }
    }

    public function clear() {
        if ($this->id == null)
            return;
        return $this->_update(self::$table, $this->id, $this->_prepare($template));
    }
    
    public function update() {

       if ($this->id == null)
            return;
        
        foreach (meno_languages() as $lang => $name) {
            // var_dump($lang, $name);die();
            $row = $this->get_request(self::$table_translate, $_REQUEST[$lang]);
            // var_dump($row);die();
            if ($row) {
                $row['text']  = clearUserText($row['text']);
                $row['title'] = clearUserText($row['title'], true);
                $this->db->replace(self::$table_translate, $row, array('id' => $this->id, 'lang' => $lang));
            }
        }
    }

    public function get_settings() {
        $settings = new settings($this->db, 'ru');
        return $settings->load('internal-mails');
    }

    public function save_settings() {
        $settings = new settings($this->db);
        $settings->replace('email-address', "Email ", clearUserText($_REQUEST['email-address']), 'internal-mails');
        $settings->replace('email-name',    " ", clearUserText($_REQUEST['email-name']), 'internal-mails');
        $settings->replace('signature', "  ", clearUserText($_REQUEST['signature']), 'internal-mails');
    }
    
    public function prepare_template_text($text, array $variables) {
        $callback = array(new _mails_prepare_callback($this, $variables), 'prepare');
		
		//var_dump($callback);die();
		
        return preg_replace_callback('/\[\[([a-z0-9_-]+)\]\]/i', $callback, $text);
    }
    
    /**
     *       ,      .
     * 
     * @param type $alias
     * @param type $email
     * @param type $data
     * @return type 
     */
    public static function add_email($alias, $title, $email, $variables) {
        $mails = self::get_instance();
        $mails->_enabled = true;
        $mails->_queue[] = array(
            $alias,
            array_merge(array(
                'title' => $title,
                'email' => $email,
                'vars'  => $variables,
            ), $options)
        );
    }

    public static function add_email_options($alias, array $options = array()) {
        $mails = self::get_instance();
        $mails->_enabled = true;
        $mails->_queue[] = array(
            $alias,
            array_merge(
                array(
                    'lang' => MENOCOM_LANG
                ),
                array_filter($options)
            )
        );
    }

    /**
     *  ,      
     * 
     * @param type $alias
     * @param type $email
     * @param type $data
     * @return type 
     */
    public static function send_email_options($alias, array $options = array()) {
		//  
        $mails    = self::get_instance();
        $template = $mails->load_by_alias($alias);
        if ($template == null)
            return false;
        $template = $template['ru'];
        if ($mails->_enabled) {
            self::add_email_options($alias, $options, $options);
            return false;
        }		
		
        //    [manager-receive = false] -   ,  
        $manager_receive = ((bool) isset($options['manager-receive']) ? $options['manager-receive'] : true);		
		
        $options = array_merge(
            array(
                'lang' => 'ru'
            ),
            array_filter($options)
        );
        // echo '<hr>';
        // var_dump($options);
        // echo '<hr>';
        $title     = $options['title'];    
        $email     = $options['email'];    
        $variables = $options['vars'];
        $lang      = $options['lang'];
        $confirm_code      = $options['vars']['confirm_code'];
        
        
        //    
        foreach ($variables as $id => $var) {
            if (!isset($template['params'][$id])) {
                unset($variables[$id]);
            }
            // var_dump($variables[$id]);
        }
        //   
        $settings      = new settings($mails->db);
        $main_settings = $settings->load('main');
        $settings      = new settings($mails->db, 'ru');
        $mail_settings = $settings->load('internal-mails');	//$settings->load('internal-mails');	

        $url_site      = $_SERVER['HTTP_HOST'];
        $title_site    = $main_settings['title']['value'];
        $e_mail        = $main_settings['email']['value'];

        //            
        $variables['site-name'] = $title_site;
        $variables['confirm_code']  = $confirm_code;
        $variables['site-url']  = $url_site;
        $variables['site-link'] = '<a href="http:/' . $url_site . '/">' . htmlentities($title_site, null, 'windows-1251') . '</a>';
        $addresses = array();		
		
        //   
        // var_dump($manager_receive);
        if ($e_mail != null && $manager_receive) {	//if ($e_mail != null && $template['manager-receive'] && $manager_receive) {
            $addresses[$e_mail] = 'Menocom Support';
        }
        if ($email != null && (!isset($template['user-receive']) || $template['user-receive'])) {
            $addresses[$email] = $title;
        }
        // var_dump($email);die();
        
        //  
        $signature = $mail_settings['signature']['value'];
        
        //   
        $mailText  = $mails->prepare_template_text($template['text'] . $signature, $variables);
        $mailTitle = $mails->prepare_template_text($template['title'], $variables);	
        // var_dump($variables);	
        
        ///  
        $mail = new PHPMailer();
        // $mail->SetLanguage('en', DR . '/classes/language/');
        $mail->IsSendmail();
        $mail->IsHTML(true);
        $mail->CharSet      = "utf-8";
        $mail->From         = iconv('cp1251','utf-8',$mail_settings['email-address']['value']);
        $mail->FromName     = iconv('cp1251','utf-8',$mail_settings['email-name']['value']);
        $mail->Subject      = iconv('cp1251','utf-8',$mailTitle);
        $mail->Body         = iconv('cp1251','utf-8',$mailText);
        $mail->AltBody      = "";		
        // var_dump($addresses);
        foreach ($addresses as $address => $address_title) {
            $mail->ClearAddresses();
            $mail->AddAddress(
                $address, 
                iconv('cp1251','utf-8',$address_title)
                );
            // var_dump($mailText);
            // var_dump($address);
            $mail->Send();
        }
    }

    /**
     *  ,      
     * 
     * @param type $alias
     * @param type $email
     * @param type $data
     * @return type 
     */
    public static function send_email($alias, $title, $email, $variables, array $options = array()) {
        return self::send_email_options($alias, 
            array_merge(array(
                'title' => $title,
                'email' => $email,
                'vars'  => $variables,
            ), $options
        ));
    }

    /**
     *  
     */
    public static function enable_queue() {
        $mails = self::get_instance();
        $mails->_enabled = true;
    }

    /**
     *     
     */
    public static function send_all() {
        $mails = self::get_instance();
        $mails->_enabled = false;
        $queue = $mails->_queue;
        $mails->_queue = array();

        foreach ($queue as $i => $arguments) {
            call_user_func_array(array('mails', 'send_email_options'), $arguments);
        }
    }
}

class _mails_prepare_callback {
    protected $_params;

    function __construct($mails, array $params) {
        $this->_params = $params;
    }
    
    function prepare(array $params) {
        $param = $params[1];
        if (isset($this->_params[$param])) {
            return $this->_params[$param];
        }
        return '';
    }
}