<?php

/**
 *
 * @improved by Arbora Sergey (http://arbora.ru)
 *
 * ,        : "   'blog__', :
 *     : catalog, catalog_sub, main_catalog - ..  ,     :
 *
 * 	- catalog 	= /catalog/
 * 	- catalog_  = /catalog/x/
 * 	- catalog__ = /catalog/x/x/
 *
 *	, ,  :D
 *
 *	,   ,      ,     - .. , ))
 *
 *
 **/

class NETComments {
    public static $table_name = 'netcomments';
	public static $table_conf = 'netconfig';
    private $db;
    public $data;
    public $id = null;

    function __construct($db,$id = null){
        $this->db = $db;
        if($id === null){
            if(isset($_REQUEST['id'])) $this->id = (int)$_REQUEST['id'];
        }else $this->id = (int)$id;
    }
	
	public function loadConfig() {
		return $this->db->query('SELECT * FROM `'.self::$table_conf.'` LIMIT 1', array(), db::FETCH_ROW);
	}
	
	public function updateConfig() {
		$arr_conf = array (
			'catalog' 		=> isset($_REQUEST['catalog']) 	 && $_REQUEST['catalog'] 	== 'on' ? 1 : 0,
			'catalog_' 		=> isset($_REQUEST['catalog_'])  && $_REQUEST['catalog_'] 	== 'on' ? 1 : 0,
			'catalog__' 	=> isset($_REQUEST['catalog__']) && $_REQUEST['catalog__']  == 'on' ? 1 : 0,
			'news' 			=> isset($_REQUEST['news']) 	 && $_REQUEST['news'] 		== 'on' ? 1 : 0,
			'news_' 		=> isset($_REQUEST['news_']) 	 && $_REQUEST['news_'] 		== 'on' ? 1 : 0,
			'blog' 			=> isset($_REQUEST['blog']) 	 && $_REQUEST['blog'] 		== 'on' ? 1 : 0,
			'blog__' 		=> isset($_REQUEST['blog__']) 	 && $_REQUEST['blog__'] 	== 'on' ? 1 : 0,
			'gallery' 		=> isset($_REQUEST['gallery']) 	 && $_REQUEST['gallery'] 	== 'on' ? 1 : 0,
			'gallery_' 		=> isset($_REQUEST['gallery_'])	 && $_REQUEST['gallery_'] 	== 'on' ? 1 : 0,
			'video' 		=> isset($_REQUEST['video']) 	 && $_REQUEST['video'] 		== 'on' ? 1 : 0,
			'video_' 		=> isset($_REQUEST['video_']) 	 && $_REQUEST['video_'] 	== 'on' ? 1 : 0,
			'section' 		=> isset($_REQUEST['section']) 	 && $_REQUEST['section'] 	== 'on' ? 1 : 0,
			'contact' 		=> isset($_REQUEST['contact']) 	 && $_REQUEST['contact'] 	== 'on' ? 1 : 0,
			'cart' 			=> isset($_REQUEST['cart']) 	 && $_REQUEST['cart'] 		== 'on' ? 1 : 0,
			'personal' 		=> isset($_REQUEST['personal'])  && $_REQUEST['personal'] 	== 'on' ? 1 : 0,
			'personal_' 	=> isset($_REQUEST['personal_']) && $_REQUEST['personal_'] == 'on' ? 1 : 0,
			'personal__' 	=> isset($_REQUEST['personal__'])&& $_REQUEST['personal__']== 'on' ? 1 : 0,
		);
		
			$is_insert = $this->db->query('SELECT * FROM `'.self::$table_conf.'` LIMIT 1', array(), db::FETCH_ROW);
			
			if (!$is_insert || empty($is_insert)) 
				$this->db->query('INSERT INTO `'.self::$table_conf.'` (`arr_conf`) VALUES ("'.mysql_real_escape_string(serialize($arr_conf)).'")');
			else 
				$this->db->query('UPDATE `'.self::$table_conf.'` SET `arr_conf`="'.mysql_real_escape_string(serialize($arr_conf)).'"');
		
	}

    public function loadAll() {
		return $this->db->query('SELECT * FROM `'.self::$table_name.'` ORDER BY `visible` ASC, `dateAdd` DESC', array(), db::FETCH_ALL);
	}
	
	public function loadById($id = null) {
		if (!$id) return false;
		return $this->db->query('SELECT * FROM `'.self::$table_name.'` WHERE `id`='.$id, array(), db::FETCH_ROW);
	}
	
	public function loadForUrl($url = null) {
		if (!$url) return false;
		return $this->db->query('SELECT * FROM `'.self::$table_name.'` WHERE `url`="'.$url.'" AND `visible`=1', array(), db::FETCH_ALL);
	}
	
	public function deleteComment() {
		if (!$this->id) return false;
		return $this->db->query('DELETE FROM `'.self::$table_name.'` WHERE `id`='.$this->id);
	}
	
	public function hideComment() {
		if (!$this->id) return false;
		return $this->db->query('UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$this->id);
	}
	
	public function showComment() {
		if (!$this->id) return false;
		return $this->db->query('UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$this->id);
	} 
		
	public function updateComment() {
		if (!$this->id) return false;
		$name = strip_tags(trim($_REQUEST['name']));
		$email = strip_tags(trim($_REQUEST['email']));
		$comment = strip_tags(trim($_REQUEST['comment']));
			
			$dateAdd = time();
			
			return $this->db->query('UPDATE `'.self::$table_name.'` SET `name`="'.$name.'", `email`="'.$email.'", `comment`="'.$comment.'", `dateAdd`="'.$dateAdd.'" WHERE `id`='.$this->id);
		
	}
	
	public function createComment($url = null) {
		if (!$url) return false;
		
		$name = strip_tags(trim($_REQUEST['name']));
		$email = strip_tags(trim($_REQUEST['email']));
		$comment = strip_tags(trim($_REQUEST['comment']));
			
			$dateAdd = time();
			
			return $this->db->query('INSERT INTO `'.self::$table_name.'` (`url`, `name`, `email`, `comment`, `dateAdd`, `visible`) VALUES ("'.$url.'", "'.$name.'", "'.$email.'", "'.$comment.'", "'.$dateAdd.'", "0")');
	}
	
	public function user_validData($values) {
		$values['name'] = strip_tags(trim($values['name']));
        $values['email'] = strip_tags(trim($values['email']));
        $values['comment'] = strip_tags(trim($values['comment']));
		
		$errors = array();
		
		if (!isset($values['name']) || $values['name'] == '') {
            $errors['name'][] = " !";
        }
		
		if (!isset($values['comment']) || $values['comment'] == '') {
            $errors['comment'][] = "    !";
        }
		
		if (!isset($values['email']) || $values['email'] == '') {
            $errors['email'][] = ('  e-mail!');
        } elseif (!filter_var($values['email'], FILTER_VALIDATE_EMAIL)) {
            $errors['email'][] = "E-mail  !";
		}
			
		
		include DR . 'kcaptcha/kcaptcha.php';
		
        if (isset($values['kcaptcha'])) {
            if (!isset($values['kcaptcha']) || $values['kcaptcha'] == '') {
                $errors['kcaptcha'][] = '    ';
            } elseif ($_SESSION['captcha_keystring'] != $values['kcaptcha']) {
                $errors['kcaptcha'][] = '     ';
            }
        }
		
		if (!empty($errors)) {
            return array(
                "values" => $values,
                "errors" => $errors
            );
        }
        return true;
	}

}
?>