<?php

class goods_articles {
    protected $_articles = array();
    
    public static function load() { }

    public static function get() { }
    
    public static function set($id, $number, $articule) { }
    
}

class price {
    ///    
    const COLUMN_ID             = 'id';
    const COLUMN_PRICE          = 'price';
    const COLUMN_AVAILABLE      = 'available';
    const COLUMN_CATEGORY       = 'group';
    const COLUMN_CATEGORY_NAME  = 'group-name';
    const COLUMN_NAME           = 'name';
    const COLUMN_CODE           = 'code';

    ///   
    const CATEGORY_AS_COLUMN    = 0;
    const CATEGORY_AS_ROW       = 1;
    const CATEGORY_AS_NOT_PRICE = 2;
    
    ///     
    const AVAILABLE_NUMERIC     = 0; ///<    
    
    ///  
    const MONEY_DOLLAR          = 0; ///< 
    const MONEY_RUBLE           = 1; ///< 

    ///  
    protected $_price_id        = null;
    protected $_name            = null;
    protected $_skip_rows       = 0;
    protected $_money_scope     = self::MONEY_RUBLE;
    protected $_available_scope = self::AVAILABLE_NUMERIC;
    protected $_category_scope  = self::CATEGORY_AS_COLUMN;
    protected $_currency_rate   = 1.0;
    protected $_prefix          = null;
    protected $_columns         = array();
    protected $_binding         = array();

    ///       save $v1
    protected static $_old_prices = array(
        1 => array (
            'name' => 'KLOSS SERVICES CORPORATION',
            'skip-rows' => 6,
            'money' => self::MONEY_DOLLAR,
            'columns' => array(
                self::COLUMN_CATEGORY => 1,
                self::COLUMN_CODE => 2,
                self::COLUMN_NAME => 3,
                self::COLUMN_AVAILABLE => 4,
                self::COLUMN_PRICE => 6
            )
        ),
        2 => array (
            'name' => '',
            'skip-rows' => 6,
            'money' => self::MONEY_RUBLE,
            'columns' => array(
                self::COLUMN_CATEGORY => 1,
                self::COLUMN_NAME => 2,
                self::COLUMN_AVAILABLE => 4,
                self::COLUMN_PRICE => 4
            )
        )
    );

    /// 
    public function __construct(array $options = array()) {
        $this->set_options($options);
    }
    
    public function set_options(array $options) {
        foreach ($options as $key => $value) {
            $key = str_replace(array('-', '.', ' '), '_', $key);
            $method = 'set_' . $key;
            if (method_exists($this, $method)) {
                $this->{$method}($value);
            }
        }
    }
    
    public function get_id() {
        return $this->_price_id;
    }
    
    public function has_new_groups() {
        foreach ($this->_binding as $id) {
            if ($id == -2) return true;
        }
        return false;
    }
    
    public function set_name($name) {
        $this->_name = trim($name);
        return $this;
    }
    
    public function get_name() {
        return $this->_name;
    }
    
    public function set_prefix($prefix) {
        $this->_prefix = $prefix;
        return $this;
    }

    ///       
    public function set_skip_rows($count) {
        $this->_skip_rows = $count;
        return $this;
    }

    ///       
    public function set_columns(array $columns) {
        $this->_columns = $columns;
        return $this;
    }

    ///         
    public function set_available_scope($scope) {
        $this->_available_scope = $scope;
        return $this;
    }

    //      
    public function set_category_scope($scope) {
        $this->_category_scope = $scope;
        return $this;
    }

    //    
    public function set_money_scope($scope) {
        $this->_money_scope = $scope;
        return $this;
    }

    //   
    public function set_currency_rate($rate) {
        $this->_currency_rate = (float) $rate;
        return $this;
    }

    public function set_binding(array $binding) {
        foreach ($binding as $name => $id) {
            $this->_binding[$name] = (int) $id;
        }
        return $this;
    }

    public function delete($only_file = false) {
        if (!$this->_price_id)
            return;

        if ($only_file != true) {
            $fn_v2    = SR.'files/.prices_imports.txt';
            $contents = (array) @unserialize(file_get_contents($fn_v2));
            if (!is_array($contents)) {
                $contents = array();
            }
            $last_id = array_shift($contents);
            foreach ($contents as $id => $options) {
                if ($options['price_id'] == $this->_price_id) {
                    unset($contents[$id]);
                    break;
                }
            }
            array_unshift($contents, $last_id);
            file_put_contents($fn_v2, serialize($contents));
        }
    }

    ///  
    public function save() {
        $isOld = true;
        $isNew = true;
        $fn_v2 = SR.'files/.prices_imports.txt';
        
        // load
        $contents = @unserialize(file_get_contents($fn_v2));
        if (!is_array($contents)) {
            $contents = array();
        }
        
        // get last id
        $last_id = (int) array_shift($contents);

        if (! $this->_price_id) {
            $isOld = false;
            $this->_price_id = ++$last_id;
        }

        $options = array(
            'price_id'          => $this->_price_id,
            'name'              => $this->_name,
            'skip_rows'         => $this->_skip_rows,
            'money-scope'       => $this->_money_scope,
            'available-scope'   => $this->_available_scope,
            'category-scope'    => $this->_category_scope,
            'columns'           => $this->_columns,
            'binding'           => $this->_binding,
            'prefix'            => $this->_prefix
        );

        if ($isOld)
            foreach ($contents as $id => $row) {
                if ($row['price_id'] == $this->_price_id) {
                    if (!$isOld) {
                        unset($contents[$id]);
                    } else {
                        $contents[$id] = $options;
                        $isNew = false;
                        $isOld = false;
                    }
                }
            }

        if ($isNew) {
            $contents[] = $options;
        }
        
        array_unshift($contents, $last_id);
        file_put_contents($fn_v2, serialize($contents));
    }

    ///   
    public static function load_all() {
        $fn_v2 = realpath(SR.'files/.prices_imports.txt');
        // var_dump($fn_v2);die();
        $prices = array();
        if ($fn_v2) {
            $contents = (array) @unserialize(file_get_contents($fn_v2));
            if (!is_array($contents)) {
                $contents = array();
            }
            array_shift($contents);
            foreach ($contents as $options) {
                $id = $options['price_id'];
                if (!isset($prices[$id])) {
                    $prices[$id] = new price($options);
                    $prices[$id]->_price_id = $id;
                }
            }
        }
        return $prices;
    }

    //   
    public static function load($price_id) { 
        $fn_v1 = realpath(SR.'files/.price_settings_ price_' . $price_id . '.txt');
        $fn_v2 = realpath(SR.'files/.prices_imports.txt');
        $price = null;

        if ($fn_v2) {
            $contents = (array) @unserialize(file_get_contents($fn_v2));
            if (!is_array($contents)) {
                $contents = array();
            }
            foreach ($contents as $id => $options) {
                if ($options['price_id'] == $price_id) {
                    $price = new price($options);
                    $price->_price_id = $options['price_id'];
                    break;
                }
            }
        } 

//        if ($price == null && $fn_v1) {
//            $binding = @unserialize(file_get_contents($fn_v1));
//            if (is_array($binding)) {
//                $price = new price(array_merge(self::$_old_prices[$price_id], array(
//                    'binding' => $binding
//                )));
//            }
//        }

        if ($price instanceof price) {
            $price->_price_id = $price_id;
            return $price;
        }
        return null;
    }

    ///     
    public function get_upload_filename() {
        return '../db/prices/price-' . $this->get_id() . '.xls';
    }
    
    ///   
    public function upload($uploadFile = null) {
        $filename = $this->get_upload_filename();
        if (file_exists($filename)) 
            unlink($filename);
        if ($uploadFile != null)
            move_uploaded_file($uploadFile, $filename);
    }
    
    ///    
    public function has_upload() {
        $filename = $this->get_upload_filename();
        return (file_exists($filename));
    }
    
    //    
    public function process(price_imports $imports) {
        $filename = $this->get_upload_filename();
        if (file_exists($filename) == false)
            return false;

        $spreadsheet = new Spreadsheet_Excel_Reader();
        $spreadsheet->setOutputEncoding('CP1251');
        $spreadsheet->read($this->get_upload_filename());

        $cells = $spreadsheet->sheets[0]['cells'];

        //   
        $category     = false;
        foreach ($cells as $id => $row) {
            //   
            if ($id < $this->_skip_rows)
                continue;

            //     .
            $new_row = array(
                self::COLUMN_ID        => $id,
                self::COLUMN_CATEGORY  => $category,
                self::COLUMN_NAME      => null,
                self::COLUMN_PRICE     => 0,
                self::COLUMN_AVAILABLE => false,
                self::COLUMN_CODE      => null
            );

            //    
            foreach ($this->_columns as $column => $position) {
                //  
                if (isset($row[$position])) {
                    $value = $row[$position];                   
                    switch ($column) {
                        case self::COLUMN_CATEGORY:
                            //     
                            $value = trim($value);
                            $new_row[self::COLUMN_CATEGORY_NAME] = $value;
                            break;
                            
                        //  
                        case self::COLUMN_AVAILABLE:
                            $new_row[$column] = (bool) $value;
                            break;

                        // 
                        case self::COLUMN_PRICE:
                            if (is_numeric($value)) {
                                switch ($this->_money_scope) {
                                    case self::MONEY_DOLLAR:
                                        $value = (float) $value / $this->_currency_rate;
                                        break;

                                    case self::MONEY_RUBLE:
                                    default:
                                        $value = (float) $value;
                                }
                            } else {
                                $value = 0;
                            }
                            if ($value != 0)
                                $value = (float) number_format($value, 2, '.', '');
                            $new_row[$column] = $value;
                            break;
                        
                        //  
                        default:
                            $new_row[$column] = trim($value);
                            break;
                    }
                }
            }

            ///  ,   .     
            switch ($this->_category_scope ) {
                case self::CATEGORY_AS_COLUMN:
                    if ($new_row[self::COLUMN_CATEGORY_NAME]) {
                        $category = $new_row[self::COLUMN_CATEGORY_NAME];
                    }
                    break;

                case self::CATEGORY_AS_NOT_PRICE:
                    if ($new_row[self::COLUMN_CATEGORY_NAME] && $new_row[self::COLUMN_PRICE] == 0) {
                        $category = $new_row[self::COLUMN_CATEGORY_NAME];
                        $new_row = false;
                    }
                    break;

                case self::CATEGORY_AS_ROW:
                    if (strlen($new_row[self::COLUMN_CATEGORY_NAME]) > 0) {
                        $category = $new_row[self::COLUMN_CATEGORY_NAME];
                        $new_row = false;
                    }
                    break;
                    
            }

            if ($new_row)
                $new_row[self::COLUMN_CATEGORY] == $category;
            if (!isset($this->_binding[$category])) {
                $this->_binding[$category] = -2;
            }
            
            if (
                    $new_row == false 
                    || empty($new_row[self::COLUMN_CATEGORY])
                    || empty($new_row[self::COLUMN_PRICE]) 
                    || $new_row[self::COLUMN_PRICE] == 0 
                    | empty($new_row[self::COLUMN_NAME])
                ) continue;

            ///   
            if ($this->_available_scope == self::AVAILABLE_NUMERIC) {
                $new_row[self::COLUMN_AVAILABLE] = (is_numeric($new_row[self::COLUMN_PRICE]) && $new_row[self::COLUMN_PRICE] != 0) ? true : false;
            }
            $new_row['availability'] = $new_row[self::COLUMN_AVAILABLE];

            ///   ,     
            if (empty($new_row[self::COLUMN_CODE])) {
                $hash = crc32($new_row[self::COLUMN_NAME]);
                $hash_suffix = ($hash < 0) ? 'N' : 'P';
                $hash =  str_replace('-', '', $hash);;
                $old_hash = $hash . str_repeat('0', max(10 - strlen($hash), 0));
                $hash = '';
                $pass = array(4, 3, 3);
                foreach ($pass as $number) {
                    for ($i = 0; $i < $number; ++$i) {
                        $hash .= $old_hash[$i];
                    }
                    $hash .= '';
                    $old_hash = substr($old_hash, $i);
                }
                $new_row[self::COLUMN_CODE] = trim($hash, '-') . $hash_suffix;
            }
            $new_row[self::COLUMN_CODE] = $this->_prefix . '' . trim($new_row[self::COLUMN_CODE]);

            ///     
            if ($new_row[self::COLUMN_AVAILABLE] && isset($this->_binding[$category]) && is_numeric($this->_binding[$category]) && $this->_binding[$category] >= 0) {
                $category_id = $this->_binding[$category];
                $new_row['import'] = $category_id;
                $imports->add_good($this, $category_id, $new_row);
                if ($category_id >= 0)
                    $this->_goods_by_imports[$category_id][] = $new_row;
            } else {
                $imports->add_good($this, null, $new_row);
            }
        }

        return true;
    }

    public function clear_categories() {
        foreach ($this->_binding as $name => $id) {
            if ($id == -2) unset($this->_binding[$name]);
        }
        return $this;
    }

    // 
    public function render_upload($url = null) {
        $url = $url ? $url : '?' . http_build_query($_GET);
        $prices = $this->load_all();
        if (empty($prices)) {
            $output = '  ';
        } else {
            $output = <<<PRE
                <form action="$url" method="post" enctype="multipart/form-data" class="style_form">
                    <table style="width:100%;" cellpadding="0" cellspacing="0">
PRE;
            foreach ($prices as $id => $price) {
                $output .= '
                    <tr>
                        <td style="width: 350px;">  "' . $price->get_name() . '"</td>
                        <td>
                            <input style="width: 250px;" type="file" name="xls_price[' . $id . ']" class="file text" />
                        </td>
                    </tr>';
            }
$output .= <<<PRE
                        <tr>
                            <td></td>
                            <td>
                                <input name="import-with-validate" class="btn" type="submit" value="  ">
                                <input name="import" class="btn" type="submit" value="">
                            </td>
                        </tr>
                    </table>
                </form>
PRE;
        }
        return $output;
    }

    // 
    public function render_control($sGroups) {
        $url = '?' . http_build_query($_GET);
        $id = $this->_price_id;
        $output = <<<PRE
        <form action="$url" method="post" class="style_form">
                <input type="hidden" name="id" value="$id" />
            <table cellspacing="0">
PRE;
        
        $output .= $this->_render_control();
        $output .= $this->_render_binding_control($sGroups);

        $output .= <<<PRE
            <tr>
                <td></td>
                <td>
                    <input class="btn" type="submit" name="save" value="" />
                    <input class="btn" type="submit" name="clear" value="  " />
                </td>
            </tr>
        </table></form>
PRE;
        return $output;
    }

    // 
    protected function _render_control() {
        $selected_value = 'selected="selected"';

        // text
        $skip_value         = $this->_skip_rows;
        $name               = $this->_name;
        $prefix             = $this->_prefix;

        // category
        $column_value       = self::CATEGORY_AS_COLUMN;
        $row_value          = self::CATEGORY_AS_ROW;
        $price_not_value    = self::CATEGORY_AS_NOT_PRICE;
        $column_select      = $this->_category_scope == self::CATEGORY_AS_COLUMN ? $selected_value : null;
        $row_select         = $this->_category_scope == self::CATEGORY_AS_ROW ? $selected_value : null;
        $price_not_select   = $this->_category_scope == self::CATEGORY_AS_NOT_PRICE ? $selected_value : null;

        // money select
        $dollar_value       = self::MONEY_DOLLAR;
        $ruble_value        = self::MONEY_RUBLE;
        $dollar_select      = $this->_money_scope == self::MONEY_DOLLAR ? $selected_value : null;
        $ruble_select       = $this->_money_scope == self::MONEY_RUBLE ? $selected_value : null;

        // available select
        $available_value    = self::AVAILABLE_NUMERIC;
        $available_select   = $this->_available_scope == self::AVAILABLE_NUMERIC ? $selected_value : null;

        $output = <<<PRE
                <tr class="options">
                    <td class="td_head" colspan="2">
                         
                    </td>
                </tr>
                <tr class="options">
                    <td>
                        <strong> *</strong>
                    </td>
                    <td>
                        <input class="forma" name="name" value="$name" />
                    </td>
                </tr>
                <tr class="options">
                    <td>
                          
                    </td>
                    <td>
                        <input class="forma" name="prefix" value="$prefix" />
                    </td>
                </tr>
                <tr class="options">
                    <td>
                        -  
                    </td>
                    <td>
                        <input class="forma" name="skip-rows" value="$skip_value" />
                    </td>
                </tr>
                <tr class="options">
                    <td>
                        <strong> *</strong>
                    </td>
                    <td>
                        <select class="forma" name="money-scope">
                            <option value="$dollar_value" $dollar_select></option>
                            <option value="$ruble_value" $ruble_select></option>
                        </select>
                    </td>
                </tr>
                <tr class="options">
                    <td>
                          
                    </td>
                    <td>
                        <select class="forma" name="available-scope">
                            <option value="$available_value" $available_select>  </option>
                        </select>
                    </td>
                </tr>
                <tr class="options">
                    <td>
                         
                    </td>
                    <td>
                        <select class="forma" name="category-scope">
                            <option value="$column_value" $column_select>   </option>
                            <option value="$row_value" $row_select> </option>
                            <option value="$price_not_value" $price_not_select> ,     </option>
                        </select>
                    </td>
                </tr>
                <tr class="options">
                    <td colspan="2" class="text1">
                          " ",          
                    </td>
                </tr>
PRE;
        
        $columns = array(
            self::COLUMN_CATEGORY   => '<strong>*</strong>',
            self::COLUMN_NAME       => '<strong>*</strong>',
            self::COLUMN_PRICE      => '<strong>*</strong>',
            self::COLUMN_AVAILABLE  => ' ',
            self::COLUMN_CODE       => ''
        );

        $output .= <<<PRE
            <tr class="options">
                <td class="td_head" colspan="2">
                     
                </td>
            </tr>
PRE;
        foreach ($columns as $column => $title) {
            $value = (isset($this->_columns[$column])) ? $this->_columns[$column] : null;
            $output .= <<<PRE
            <tr class="options">
                <td>$title</td>
                <td>
                    <input class="forma" name="columns[$column]" value="$value" />
                </td>
            </tr>
PRE;
        }
        return $output;
    }

    protected function _render_options($data, $current, $l = 0) {
        $output = '';
        foreach ($data as $row) {
            $output .= '<option value="' . $row['id'] . '"' . ($current == $row['id'] ? ' selected="selected"' : '') . '>' . str_repeat('&nbsp;', $l * 4) . $row['name'] . '</option>';

            if (!empty($row['childs'])) {
                $output .= $this->_render_options($row['childs'], $current, $l + 1);
            }
        }
        return $output;
    }

    protected function _render_binding_control($sGroups) {
        if (empty($this->_binding))
            return '';

        $categoryTable = '';
        //$categoryTable .= '<form action="" method="post"><table>'
        $categoryTable .= '
                <tr class="options">
                    <td class="td_head" colspan="2">
                         
                    </td>
                </tr>
                <tr>
                    <td class="table_head">  </td>
                    <td class="table_head">  </td>
                </tr>';
        foreach ($this->_binding as $priceGroup => $priceId) {
            $catalogTreeHtml = $this->_render_options($sGroups, isset($priceId) ? $priceId : null);

            $tag = '';
            if ($priceId == -2 || !isset($priceId)) {
                $tag = 'strong';
            } elseif ($priceId == -1) {
                $tag = 'em';
            }
            
            $categoryTable .= '
                <tr>
                    <td class="table_tr">' . ($tag ? '<' . $tag . '>' . $priceGroup . '</' . $tag . '>' : $priceGroup) . '</td>
                    <td class="table_tr">
                        <select name="binding[' . htmlspecialchars($priceGroup) . ']">
                            <option value="-2"' . ($priceId == -2 || !isset($priceId) ? ' selected="selected"' : '') . '>-</option>
                            <option value="-1"' . ($priceId == -1 ? ' selected="selected"' : '') . '> </option>
                            ' . $catalogTreeHtml . '
                        </select>


            </td></tr>';
        }

        //$categoryTable .= '</table>';

        if (!empty($_POST['price_type'])) {
            // $categoryTable .= '<input type="hidden" name="price_type" value="' . $_POST['price_type'] . '" />';
        }

        if (!empty($_POST['price_col'])) {
            // $categoryTable .= '<input type="hidden" name="price_col" value="' . $_POST['price_col'] . '" />';
        }

        //$categoryTable .= '<input type="submit" name="save_changes" value="" />';
        //</form>';

        return $categoryTable;
    }
}

class price_imports {
    ///
    protected $_all_goods     = array();
    protected $_imports_goods = array();
    protected $_add_without_category = true;

    public function __construct($add_without_category = true) {
        $this->_add_without_category = $add_without_category;
    }

    public function add_good($price, $category_id, array $good) {
        if ($category_id) {
            $this->_imports_goods[$category_id][] = $good;
            $this->_all_goods[] = $good;
        } elseif ($this->_add_without_category) {
            $this->_all_goods[] = $good;
        }
        return $this;
    }

    //   
    public function import() {
        global $tov_prod;
        $output = '';
        
        $dataToUpload = $this->_imports_goods;

        if (empty($dataToUpload)) {
            return;
        }
        //     - array(id, ) -  
        $_tovDb = array_map('trim', file($tov_prod));
        $tovDb = array();
        $lastId = (int) array_shift($_tovDb);

        $codeDb = array();
        foreach ($_tovDb as $i => $row) {
            $row = explode(' ~ ', $row);
            $tovDb[$i] = $row;

            if (!empty($row[10])) {
                $codeDb[$row[10]] = array(
                    'index'        => $i,
                    'availability' => $row[12],
                    'processed'    => $row[13]
                );
            }
            unset($_tovDb[$i]);
        }
        $stat = array(
            'all' => array(
                'insert' => 0,
                'update' => 0
            )
        );
        $dataToWrite = array();

        //   
        $newArts = array();
        foreach ($dataToUpload as $groupId => $rows) {
            foreach ($rows as $row) {
                if (!isset($stat[$row['group']])) {
                    $stat[$row['group']] = array(
                        'insert' => 0,
                        'update' => 0
                    );
                }

                $newArts[] = $row['code'];

                if (isset($codeDb[$row['code']]) && isset($tovDb[$codeDb[$row['code']]['index']])) {
                    $stat[$row['group']]['update'] += 1;
                    $stat['all']['update'] += 1;
                    $good = $tovDb[$codeDb[$row['code']]['index']];

                    //12 -  (1 - , 3 - )
                    //13 - 
                    if ($row['availability'] == 0 && $codeDb[$row['code']]['availability'] == 3) {
                        $good[12] = 3;
                    } elseif ($row['availability'] == 0 && $codeDb[$row['code']]['availability'] == 1) {
                        $good[12] = 3;
                    } elseif ($row['availability'] == 0 && $codeDb[$row['code']]['availability'] == 2) {
                        $good[12] = 2;
                    } elseif ($row['availability'] == 1) {
                        $good[12] = 1;
                    } elseif ($row['availability'] == 1 && $codeDb[$row['code']]['availability'] == 1) {

                    }
                    /// 0 === 3
                    /* if ($row['availability'] == 1 && $codeDb[$row['code']]['availability'] == 3) {
                      $good[12] = 1;
                      //                    $good[13] = 0;
                      } elseif ($row['availability'] == 1 && $codeDb[$row['code']]['availability'] == 3) {
                      //                    $good[12] = 1;
                      //                    $good[13] = 1;
                      } elseif ($row['availability'] == 0 && $codeDb[$row['code']]['availability'] == 1) {
                      $good[12] = 3;
                      //                    $good[13] = ;
                      } else {
                      $good[12] = 0;
                      $good[13] = 0;
                      }
                     */
                    //$good[4] = $good[11] = $row['name'];
                    $good[6] = $row[ price::COLUMN_PRICE ];
                    // $good[1] = $groupId;

                    $tovDb[$codeDb[$row['code']]['index']] = $good;
                } else {
                    // 
                    if ($row['availability'] == 0) {
                        continue;
                    }
                    $stat[$row['group']]['insert'] += 1;
                    $stat['all']['insert'] += 1;
                    $tovDb[] = array(
                        0 => ++$lastId,
                        1 => $groupId,
                        2 => 1,
                        3 => 0,
                        4 => $row['name'],
                        5 => '',
                        6 => $row[ price::COLUMN_PRICE ],
                        7 => '',
                        8 => $lastId,
                        9 => 0,
                        10 => $row['code'],
                        11 => $row['name'],
                        12 => $row['availability'] == 1 ? 1 : 3,
                        13 => 0,
                        14 => 0,
                        15 => 0,
                        16 => 0,
                        16 => 0,
                        17 => 'end',
                        18 => 'noIMG'
                    );
                }
            }
        }
        /*
         *  .   ,       .  ,   "  "
         *   /  
         */
        foreach($tovDb as $k=>$v){
            if (!in_array($v[10], $newArts) && $tovDb[$k][12] == 1){
                $tovDb[$k][12] = 3;
           }
        }
        array_unshift($tovDb, $lastId);

        foreach ($stat as $g => $data) {
            if ($g != 'all')
                $output .= '<b>' . $g . ':</b><br /><p>';
            else
                $output .= '<b> :</b><br /><p>';
            if (isset($data['insert']))
                $output .= ': ' . $data['insert'] . '<br />';
            if (isset($data['update']))
                $output .= ': ' . $data['update'] . '<br />';
            $output .= '</p>';
        }

        $tovDb = array_map('implodeDb', $tovDb);
        file_put_contents($tov_prod, implode("\n", $tovDb));
        return $output;
    }

    public function render_imports(array $categories, $onlyImported = false) {
        $output = <<<PRE
            <table class="table table-condensed">
            <tr>
                <td class="table_head"></td>
                <td class="table_head"></td>
                <td class="table_head">  </td>
                <td class="table_head">  </td>
                <td class="table_head"></td>
            </tr>
PRE;

        foreach ($this->_all_goods as $good) {
            $name     = htmlentities($good['name'], null, 'windows-1251');
            $category = htmlentities($good['group'], null, 'windows-1251');
            
            $import_in = ' &mdash; ';

            $class = 'no_imported';
            if (isset($good['import'])) {
                $imp = $good['import'];
                if ($imp == -2) {
                    $import_in = ' ';
                    if ($onlyImported)
                        continue;
                } elseif ($imp == -1) {
                    //$import_in = ' ';
                    //if ($onlyImported)
                    continue;
                }  else {
                    if (isset($categories[$imp]) && !empty($categories[$imp])) {                    
                        $import_in = $categories[$imp]['name'];
                        $class = '';
                    }
                }
            } elseif ($onlyImported) 
                continue;

            $output .= <<<PRE
            <tr>
                <td class="table_tr {$class}" style="white-space: nowrap;">{$good['code']}</td>
                <td class="table_tr {$class}">{$name}</td>
                <td class="table_tr {$class}">{$category}</td>
                <td class="table_tr {$class}" style="white-space: nowrap;">{$import_in}</td>
                <td class="table_tr {$class}" style="white-space: nowrap;">{$good['price']}</td>
            </tr>
PRE;
        }

        $output .= '</table>';
        if ($onlyImported == false) {
            $url = '?' . http_build_query($_GET) . '&import';
            $output .= <<<PRE
            <form action="$url" method="post">
                <table cellpadding="0" cellspacing="0">
                    <tr>
                        <td>
                            <input name="import" class="btn" type="submit" value="">
                        </td>
                    </tr>
                </table>
            </form>
PRE;
            }
        return $output;
    }
}