<?php       
class Smsfeedback
{
     
    const ERROR_EMPTY_API_LOGIN = 'Empty api login not allowed';
    const ERROR_EMPTY_API_PASSWORD = 'Empty api password not allowed';
    const ERROR_EMPTY_RESPONSE = 'errorEmptyResponse';
    const ERROR_CURL_NOT_INSTALLED = 'errorCurlNotInstalled';
     
    protected $_apiLogin = null;
     
    protected $_apiPassword = null;
     
    protected $_host = 'json.api.smsfeedback.ru';
     
    protected $_packetSize = 200;
     
    protected $_results = array();
     
    public function __construct($apiLogin, $apiPassword)
    {
        $this->_setApiLogin($apiLogin);
        $this->_setApiPassword($apiPassword);
    }
     
    private function _setApiLogin($apiLogin)
    {
        if (empty($apiLogin)) {
            throw new Exception(self::ERROR_EMPTY_API_LOGIN);
        }
        $this->_apiLogin = $apiLogin;
    }
     
    private function _setApiPassword($apiPassword)
    {
        if (empty($apiPassword)) {
            throw new Exception(self::ERROR_EMPTY_API_PASSWORD);
        }
        $this->_apiPassword = $apiPassword;
    }
     
    public function setHost($host)
    {
        $this->_host = $host;
    }
     
    public function getHost()
    {
        return $this->_host;
    }
     
    private function _sendRequest($uri, $params = null)
    {
        $url = $this->_getUrl($uri);
        $data = $this->_formPacket($params);
 
        if (!function_exists('curl_init')){
            if (empty($body)) {
                throw new Exception(self::ERROR_CURL_NOT_INSTALLED);
            }    
        }
        $client = curl_init($url);
        curl_setopt_array($client, array(
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_HEADER => false,
            CURLOPT_POST => true,
            CURLOPT_HEADER => false,
            CURLOPT_HTTPHEADER => array('Host: ' . $this->getHost()),
            CURLOPT_POSTFIELDS => $data,
        ));
         
        $body = curl_exec($client);
        curl_close($client);
        if (empty($body)) {
            throw new Exception(self::ERROR_EMPTY_RESPONSE);
        }
        $decodedBody = json_decode($body, true);
        if (is_null($decodedBody)) {
            throw new Exception($body);
        }
        return $decodedBody;
    }
     
    private function _getUrl($uri)
    {
        return 'http://' . $this->getHost() . '/' . $uri . '/';
    }
     
    private function _formPacket($params = null)
    {
        $params['login'] = $this->_apiLogin;
        $params['password'] = $this->_apiPassword;
        foreach ($params as $key => $value) {
            if (empty($value)) {
                unset($params[$key]);
            }
        }
        $packet = json_encode($params);
        return $packet;
    }
     
    public function getPacketSize()
    {
        return $this->_packetSize;
    }
     
    public function send($messages, $statusQueueName = null, $scheduleTime = null)
    {
        $params = array(
           'messages' => $messages,
           'statusQueueName' => $statusQueueName,
           'scheduleTime' => $scheduleTime,
        );
        return $this->_sendRequest('send', $params);
    }
     
    public function status($messages)
    {
        return $this->_sendRequest('status', array('messages' => $messages));
    }
     
    public function statusQueue($name, $limit)
    {
        return $this->_sendRequest('statusQueue', array(
            'statusQueueName' => $name,
            'statusQueueLimit' => $limit,
        ));
    }
     
    public function credits()
    {
        return $this->_sendRequest('credits');
    }
     
    public function senders()
    {
        return $this->_sendRequest('senders');
    }
	//@author: srgg
	//   :
    function handleSending($system_phone_number,$text_to_send){	

		$sms_text = iconv('windows-1251', 'UTF-8', $text_to_send);

		$_sms_addr = explode(';',$system_phone_number);	
		
		if (!empty($_sms_addr)){
			//var_dump($gate->credits()); //   
			//var_dump($gate->senders()); //    
			$messages = array();
			
			foreach($_sms_addr as $client_id => $sms_to){
				
				$messages[] = array('cliendId' => $client_id+1, 	//  
									'phone'    => trim($sms_to), 	// 
									'text'     => "{$sms_text}",
									'sender'   => 'Eka-raduga'
									);
			}
			$send_status = $this->send($messages, 'ekaradugaQueue'); //   sms
			if ($send_status['status']!='ok'){
				//    : 644(?)
				$log = @file_get_contents(SR.'files/send_log.txt');
				//if (!$log) echo "<div>!     ".SR."send_log.txt!</div>";
				$last_log="\n [".date('Y-m-d H:i:s').'] '.$send_status['status'];
				$log.= $last_log;
				file_put_contents(SR.'files/send_log.txt', $log);
				if ($_SESSION['TEST']) {
					echo "<h1 style='color:red;'>SMS  !</h1>";
					echo "<div>last_log= $last_log</div>";
					echo "<div>log: file_put_contents: ".SR."files/send_log.txt</div>";
					var_dump("<h1>messages:</h1><pre>",$messages,"</pre>");
				}
				
				return false;
			
			}else{ 
				
				return true;
			}
		}		
	} 
}
 
?>