<?php

/**
 * @popularized by Arbora Sergey (http://arbora.ru)
 *
 *      -      )))
 *    ,  ,  )))
 *
 **/

class Template {
    protected $_dirs = array();
    
    protected $_filename = null;

    protected $_index    = null;
    
    protected $_vars = array();
    
    public function get($name) {
        if (isset($this->_vars[$name])) {
            return $this->_vars[$name];
        }
        return null;
    }
    
    public function set($name, $value) {
        $this->_vars[$name] = $value;
        return $this;
    }
    
    public function clear() {
        $this->_vars = array();
        return $this;
    }
    
    public function __construct() {
        //   
        $this->_dirs[] = rtrim(DR,'/') . '/inc/scripts/';
        //    
        $this->_dirs[] = rtrim(TR,'/') . '/scripts/';
        
        if (SITE_TYPE == 'link'){
            //       (    ,    ))))
            $this->_dirs[] = rtrim(SR,'/') . '/inc/scripts/';
        }
    }
    function render($filename) {
        $this->_filename = ltrim($filename, DIRECTORY_SEPARATOR);
        $this->_index    = 0;
        return $this->renderBase();
    }
    
    function renderWrap($filename, $content, $wrapEmpty = false) {
        if ($content == null && !$wrapEmpty)
            return '';

        $this->set('items', $content);
        $result = $this->render($filename);
        if ($result === false)
            return $content;
        else 
            return $result;
    }
    
    function renderBase() {
        $dirs = array_reverse($this->_dirs);
        for ($i = $this->_index; $i < count($dirs); ++$i) {
            $this->_index += 1;
            
            $fullname = $dirs[$i] . $this->_filename;
            // var_dump($fullname);
            if (file_exists($fullname)) {
                ob_start();
                require $fullname;
                $content = ob_get_contents();
                ob_end_clean();
                return $content;
            }
        }
        return false;
    }
}