<?php
/**
 * WIDGETS -  ,  ,  
 * @author:   (http://arbora.ru)
 *
 * : (side)
 * 0 -  
 * 1 - 
 * 2 - 
 *
 *  :
 * data[widget_id] = widget_data + (positions = array('side','pos'))
 *
 * 
 *
*/
// call-back     
function wgt_cmp($a,$b){
	return $a['pos'] < $b['pos'] ? -1 : 1;
}

class widgets {
	public static $table_name = 'widgets';
	public static $table_pages = 'widget_pages';
	
	private $db = null;
	private $page = null;

	public static $data = array();
	public static $left_sidebar = null;
	public static $right_sidebar = null;

	function __construct($db = null){
		$this->db = $db;
	}
	public function load($page=null){
		if ($page){
			$this->page = $page;
		}else if($this->page && isset(self::$data) && count(self::$data)) return self::$data;
		//  
		$q = 'SELECT * FROM `'.self::$table_name.'` WHERE `visible`';
		if(!$widgets = $this->db->resultAsArray($q)) return false;

		self::$data = array();
		//      
		//     -    
		$page_data = $this->getPageData($this->page);
		if (!$page_data) return 0;
		$this->left_sidebar = $page_data['left_sidebar'];
		$this->right_sidebar = $page_data['right_sidebar'];
		if(!$page_data['positions']){
			foreach($widgets as $row){
				if ($row['object_id']){ //  
					$obj = new $row['object']($this->db);
					$obj_data = $obj->loadById($row['object_id']);
					$row['name'] = $obj_data['name'];
				}else{
					self::$data[$row['id']] = array_merge($row, array('side' => 0,'pos' => 0));
				}
			}
			return self::$data;
		}
		$positions = unserialize($page_data['positions']);
		foreach($widgets as $row){
			if ($row['object_id']){ //  
				$obj = new $row['object']($this->db);
				$obj_data = $obj->loadById($row['object_id']);
				$row['name'] = $obj_data['name'];
			}
			if ($positions[$row['id']]){
				self::$data[$row['id']] = array_merge($row, array('side' => $positions[$row['id']][0],'pos' => $positions[$row['id']][1]));
			}else{
				self::$data[$row['id']] = array_merge($row, array('side' => 0,'pos' => 0));
			}
		}
		//   
		usort(self::$data,'wgt_cmp');
		return self::$data;
	}

	function getPageData($page = 'default'){
		$page_data = $this->db->query('SELECT * FROM `'.self::$table_pages.'` WHERE `page`="'.$page.'"');
		return $page_data ? mysql_fetch_assoc($page_data) : false;		
	}
	function getPages(){
		return $this->db->resultAsArray('SELECT * FROM `'.self::$table_pages.'`');
	}

	//       (,)
	function create(){
		$object = $_REQUEST['object'];
		$id = $_REQUEST['object_id'];
		if (!$id || empty($id))return false;
		$this->db->insert(self::$table_name,array('object' => $object, 'object_id' => $id));
	}

	//   
	//   " "
	function create_page(){
		$title = $_REQUEST['title'];
		$page = $_REQUEST['page'];
		if (empty($title) || empty($page))return false;
				
		$default_data = $this->getPageData('default');
		$default_data['page'] = $page;
		$default_data['title'] = $title;
		unset($default_data['id']);
		
		$this->db->insert(self::$table_pages,$default_data);
	}

	//   
	function update_page(){
		$id = $_REQUEST['page_id'];
		$page = $_REQUEST['page'];
		$title = $_REQUEST['title'];
		if (empty($title) || empty($page) || empty($id))return false;
		
		$this->db->update(
			self::$table_pages,
			array('title' => $title, 'page' => $page),
			array('id' => $id)
		);
	}


	function save(){
		$page = $_REQUEST['wpage'] ? $_REQUEST['wpage'] : $this->page;
		$data = array();
		$array = array('left_sidebar' => isset($_REQUEST['left_sidebar']), 'right_sidebar' => isset($_REQUEST['right_sidebar']));
		$queries = array();
		if ($_POST['center'] && count($_POST['center']))
		foreach($_POST['center'] as $id => $pos){
			$pos = array_flip($pos);$pos=$pos[''];
			$data[$id] = array(0,$pos);
		}
		if ($_POST['left'] && count($_POST['left']))
		foreach($_POST['left'] as $id => $pos){
			$pos = array_flip($pos);$pos=$pos[''];
			$data[$id] = array(1,$pos);
		}
		if ($_POST['right'] && count($_POST['right']))
		foreach($_POST['right'] as $id => $pos){
			$pos = array_flip($pos);$pos=$pos[''];
			$data[$id] = array(2,$pos);
		}
		if(count($data)){
			$data = serialize($data);
			$array = array_merge($array,array('positions' => $data));
		}
		return $this->db->update(self::$table_pages, $array, array('page' => $page));
	}


	/************************************
	*************************************
	*     ? *
	*************************************
	*************************************/
	
	/*  
	function is_where($module_name) {
		$link = '/'.$_GET['qs'];
		return $this->db->getOne(self::$table_name,'id',array('object' => $module_name,'link' => $link));	
	}*/

	function delete($id=null){
		if (!$id && isset($_REQUEST['id']) && is_numeric($_REQUEST['id']))
			$id = $_REQUEST['id'];
		$this->db->delete(self::$table_name,array('id' => $id));
	}
	function delete_page($id=null){
		if (!$id && isset($_REQUEST['id']) && is_numeric($_REQUEST['id']))
			$id = $_REQUEST['id'];
		$this->db->delete(self::$table_pages,array('id' => $id));
	}



}
?>