<?php

class goods_brands extends Module{

    /**
     *  
     * @var table
     */
static $table = 'catalog_brands';

    public $id;
    
    function setId($id){
        $this->id=$id;
    }

    public function load(){
        return $this->db->query('SELECT * FROM :table ORDER BY `pos`',array('table'=>db_name(self::$table)),db::FETCH_ALL);
    }

    /**
     *   
     * @param int $id
     */
    public function load_by_id($id){
        return $this->db->query('SELECT * FROM :table WHERE id=:id',array('table'=>db_name(self::$table),'id'=>$id),db::FETCH_ROW);
    }

	public function load_by_url($url){
        return $this->db->query('SELECT * FROM :table WHERE url=:url',array('table'=>db_name(self::$table),'url'=>$url),db::FETCH_ROW);
    }    

    public function load_goods_by_brand($brand_id){
        //
        $where =array('`brand-id`=:brand_id');
        global $_shop_settings;
        if (!trim($_shop_settings['show_missing_good']['value']))
            $where[] = '`vis`';
        $where = implode('and ',$where);
        $goods_list = $this->db->query('SELECT * FROM :goods_table WHERE '.$where.' ORDER BY cid, name',array('goods_table'=>db_name(goods::$table),'brand_id'=>$brand_id),db::FETCH_ALL);
        $return = array();
        //   
        $catalog = new catalog($this->db);
        foreach($goods_list as $good){
            if (!$catalog->checkVisible($good['cid']))
                continue;
            $return[$good['cid']][]= $good;
        }
        return $return;
    }

    /**
     *     id
     * @param array $array
     */
    public function load_by_array(array $array = array()){
        $in = implode(',',$array);
        return $this->db->query('SELECT * FROM :table WHERE id IN (:in)',array('table'=>db_name(self::$table),'in'=>db_expr($in)),db::FETCH_ALL);
    }

    /**
     * 
     * @param string $name
     * @return boolean
     */
    public function create() {
        $insert = $this->db->get_request(self::$table,$_POST);
        return $this->db->insert(self::$table, $insert);
    }
    /**
     * 
     * @param int $id
     * @return boolean
     */
    public function delete() {
        return $this->db->delete(self::$table,array('id'=>$this->id));
    }

    /**
     * 
     */    
	function setUrlAndUpdate($id){
		if (!isset($id) || empty($id))return false;
		$update = array('url' => $id);
		global $db;
		return $db->update(self::$table,$update,array('id'=>$id));
	}
    public function update() {
		$update = $this->db->get_request(self::$table,$_POST);
		return $this->db->update(self::$table,$update,array('id'=>$this->id));
    }

    public function get_brand_name($id) {
        return $this->db->query('SELECT `name` FROM :table WHERE id=:id',array('table'=>db_name(self::$table),'id'=>$id),db::FETCH_RESULT);
    }
    public function get_brand_url($id) {
        return $this->db->query('SELECT `url` FROM :table WHERE id=:id',array('table'=>db_name(self::$table),'id'=>$id),db::FETCH_RESULT);
    }

}