<?php

require_once DR . '/func.php';
require_once DR . '/classes/class.template.php';

/**
 *  :)
 */
class App {
    protected static $_instance;

    protected $_modules = array();

    protected $_resources = array();

    protected function __construct() {

        global $config, $db, $account, $settings, $loader;

        // var_dump(!$config instanceof config);die();

        if (!$config instanceof config)   $config     = Config::load();
        if (!$settings instanceof settings) $settings   = new settings();
        if (!$db instanceof db){
            $db = new db();
            //    
            $db->connect();
        }       
        if (!$account instanceof account){
            $account = new account();
            $account->load_current();
        }
        if (!$loader instanceof loader){
            $loader = new loader();
            //  
            $loader->load();
        }   
        $this->_resources['config']   = $config   ;
        $this->_resources['db']       = $db       ;
        $this->_resources['account']  = $account  ;
        $this->_resources['settings'] = $settings ;
        $this->_resources['loader']   = $loader   ;
        
        /*
        $this->_resources['config']   = $config   = Config::load();
        $this->_resources['db']       = $db       = new Db();
        $this->_resources['account']  = $account  = new Account($db);
        $this->_resources['settings'] = $settings = new Settings($db);
        $this->_resources['loader']   = $loader   = new Loader($db);
        */
        /*
        //   ,     
        ini_set("display_startup_errors", $config->debug->display_error);
        ini_set("display_errors", $config->debug->display_error);
        ini_set("html_errors", $config->debug->display_error);
        */
        $iterator = new DirectoryIterator(DR . '/classes/modules');
        var_dump($iterator);die();
        foreach ($iterator as $file) {
            if ($file->isFile()) {
                $filename = $file->getFilename();
                if (strpos($filename, ".php") == strlen($filename) - 4) {
                    require_once $file->getPathname();
                }
            }
        }
    }
    
    /**
     *
     * @return App 
     */
    public static function get() {
        if (self::$_instance == null) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    public function __get($name) {
        if (isset($this->_resources[$name])) {
            return $this->_resources[$name];
        }

        throw new MenoCMS_Exception("   '$name'  !");
    }
    
    public function __call($name, $arguments) {
        return self::get()->call_handle_array($name, $arguments);
    }
    
    public function add_module($name, $module) {
        $this->_modules[$name] = $module;
        return $this;
    }

    /**
     * ->call_handle("search", $text, $result);
     * 
     * @param type $name
     * @param type $arguments ...
     * @return  
     */
    public function call_handle($name, $arguments) {
        $arguments = func_get_args();
        $name      = array_shift($arguments);
        return $this->call_handle_array($name, $arguments);
    }

    /**
     * ->call_handle("search", $text, $result);
     * 
     * @param type $name
     * @param type $arguments ...
     * @return  
     */
    public function call_handle_array($name, array $arguments = array()) {
        $result    = array();
        foreach ($this->_modules as $key => $module) {
            if (method_exists($module, $name)) {
                $result[$key] = call_user_func_array(array($module, $name), $arguments);
            }
        }
        return $result;
    }

    /**
     *
     * @param type $module
     * @param type $name
     * @param type $arguments
     * @return type 
     */
    public function call_module_handle($module, $name, array $arguments = array()) {
        $arguments = func_get_args();
        $module    = array_shift($arguments);
        $name      = array_shift($arguments);

        $arguments = func_get_args();
        $name      = array_shift($arguments);
        if (isset($this->_modules[$module])) {
            $module = $this->_modules[$module];
            if (method_exists($module, $name)) {
                return call_user_func_array(array($module, $name), $arguments);
            }
        }
        return null;
    }
}