<?php
if (!$loader->serviceActive('personal')){
    go404(); return;
}

$header_sect = $loader->serviceName('personal');
$module = 'personal';
navigation::add_breadcrumb($loader->serviceName('personal'),'/personal');

$personal = new personal();

$render         = new Template();
$item_render    = new Template();


if (!empty($db->qa[2]) && is_numeric($db->qa[2])) {

    $personal->load_persona((int) $db->qa[2]);
    if (!empty($personal->persona)) {
        $worker = $personal->persona;
        $header_sect = $worker->name;
        $officeId = (int) $db->qa[1];
        $office = personal::get_office_on_id($officeId);

        navigation::add_breadcrumb($office['name'],'/personal/'.$db->qa[1]);
        navigation::add_breadcrumb($worker->name,'/personal/'.$worker->pid.'/'.$worker->id);

        $dimploms = new subgallery($db);
        $dimploms->load($worker->id, 'persona');
        $gallery = '';
        if (!empty($dimploms->gallery)) {    
            $items = '';
            foreach ($dimploms->gallery as $v) {
                if (!$v['visible'] || empty($v['file'])) {
                    continue;
                }
                
                $v['href'] = subgallery::$url . '' . $v['file'];
                $v['image'] = (subgallery::$url . 's' . $v['file']);
                if (!is_file(SR.$v['image'])){
                    $v['image'] = noimg('gallery');
                }        
            
            $items .= $item_render
                 ->clear()
                 ->set('item', $v)
                 ->render('/gallery/album/item.php');

            }

            if ($items){
                $gallery = $render->renderWrap('/gallery/album/list.php', $items);
            }
        }
     
        $forms = new forms($db);
        $error = array(); 
        $form = $forms->load_on_alias('ask_persona');
        $success = '';
        if($forms->submit($errors,array(),$worker->email)){
            $success = '  .';
        }else $form = show_form($form,$_REQUEST,$errors);

        $items = '';

        $body_sect .= $render
            ->clear()
            ->set('success', $success)
            ->set('form', $form)
            ->set('worker', $worker)
            ->set('gallery', $gallery)
            ->render('/personal/item/show.php');
        
    }
} elseif (!empty($db->qa[1]) && is_numeric($db->qa[1])) {
    $officeId = (int) $db->qa[1];
    $workers = $personal->loadAllWorkers($officeId);
        $office = personal::get_office_on_id($officeId);
    navigation::add_breadcrumb($office['name'],'/personal/'.$db->qa[1]);

    if (!empty($workers) && is_array($workers)) {
        $items = '';
        foreach ($workers as $worker) {
            $link = '/'.$module.'/' . $worker['pid'] . '/' . $worker['id'].'/';
            $img = noimg('personal');
            if ($worker['photo']) {
                $img = $personal->getPath() . personal::$imgPrefix . $worker['photo'];
                $img = (file_exists(SR . $img)) ? '/'.$img : noimg('personal');
            }
            $items .= $item_render
                                ->clear()
                                ->set('href', $link)
                                ->set('img', $img)
                                ->set('worker', $worker)
                                ->render('/personal/item/item.php');
        }
        $body_sect .= $render
            ->clear()
            ->renderWrap('/personal/item/list.php', $items);
    }
} else {
    $offices = personal::get_all_office();
    if (!empty($offices) && is_array($offices)) {
        $body_sect .= '<div class="worker_list">';
        foreach ($offices as $office) {
            if(!$office['visible'])
                continue;
            $link = '/'.$module.'/' . $office['id'].'/';
            if ($office['photo']) {
                $img = $personal->getPath() . personal::$imgPrefix . $office['photo'];
                $img = (file_exists(SR . $img)) ? '/'.$img : noimg('office');
            }
            $office['name'] = htmlspecialchars($office['name']);
            $items .= $item_render
                                ->clear()
                                ->set('href', $link)
                                ->set('img', $img)
                                ->set('office', $office)
                                ->render('/personal/item.php');
        }
        $body_sect .= $render
            ->clear()
            ->renderWrap('/personal/list.php', $items);
    }
}
?>