<?php
if (!$loader->serviceActive('search')){
    go404(); return;
}
$min_query_length = 2;

define ('RESULTS_EVERY_TABLE', 10); //      ,   [N+1] -    
define ('RESULTS_ON_PAGE', 20); //    

//   ,     .
    /**
    *     :
    *   1) `title`
    *   2) `text`
    */    
    $modules_configs = array(
        'catalog_sect' => array(
            'title'         => '',
            'search_title'  => 'name',
            'search_text'   => 'content',
            'object_id'     => 'id',
            'object_type'   => 'catalog_sect',
            'where'         => array('vis'),
            'matches'        => array('name','content')
        ),
        'catalog_goods' => array(
            'title'         => '',
            'search_title'  => 'name',
            'search_text'   => 'pre_content',
            'object_id'     => 'id',
            'object_type'   => 'catalog_goods',
            'where'         => array('vis'),
            'matches'        => array('name','content','t_kod')
        ),
        'infosection' => array(
            'title'         => '',
            'search_title'  => 'name',
            'search_text'   => 'text',
            'object_id'     => 'id',
            'object_type'   => 'infosection',
            'where'         => array('visible'),
            'matches'        => array('name','text')
        ),
        'news' => array(
            'search_title'  => 'name',
            'title'         => '',
            'search_text'   => array('anons','text'),
            'object_id'     => 'id',
            'object_type'   => 'news',
            'where'         => array('visible'),
            'matches'        => array('name','anons','text')
        ),
        'blog' => array(
            'title'         => '',
            'search_title'  => 'name',
            'search_text'   => array('anons','text'),
            'object_id'     => 'id',
            'object_type'   => 'blog',
            'where'         => 'visible',
            'matches'        => array('name','anons','text')
        ),
        'gallery' => array(
            'title'         => '',
            'search_title'  => 'name',
            'search_text'   => 'text',
            'object_id'     => 'id',
            'object_type'   => 'gallery',
            'where'         => array('visible'),
            'matches'        => array('name','text')
        ),
         'subgallery' => array(
            'title'         => '',
            'search_title'  => 'name',
            'search_text'   => 'file',
            'object_id'     => 'id',
            'object_type'   => 'subgallery',
            'where'         => array('visible'),
            'matches'        => array('name','caption')
        )
    );

$baseQueries = array();



$render         = new Template();
$item_render    = new Template();
$stock          = new goods_stock($db);



//    mysql-
function mysql_brackets(array $array){
    $result = array();
    foreach ($array as $k => $v) {
        $result[$k] = '`'.$v.'`';
    }
    return $result;
}

function btn_more($obj_type){
    global $modules_configs, $loader;
    return '<div style="text-align:right;" class="btn-search-more-wrap">
        <a href="/search/?q='.$_GET['q'].'&amp;service='.$obj_type.'" class="btn-search-more">   '.$loader->serviceName($obj_type).'</a></div>';
}


//       
function search_query_generator($tables){
    global $modules_configs;
    $result = array();
    if (is_array($tables)){
        foreach ($tables as $k) {
            if (isset($modules_configs[$k]))
                $result[$k] = $modules_configs[$k];
        }
    }else{
        if (isset($modules_configs[$tables]))
            $result[$tables] = $modules_configs[$tables];
    }
    return $result;
}


/**
 *   ,     . 
 *  2  
 * 1 -      N .
 * 2 -    $_GET[service] .
 */



/* , ..      ,     .
if (!$_GET['service']){ // 1-   ( )
    $modules = search_query_generator(
        array(
            'catalog_sect',
            'catalog_goods',
            'infosection',
            'news',
            'blog',
            'gallery',
            'subgallery'
        )
    );
}else{ // 2-   (1 )
    if (isset($modules_configs[$_GET['service']])){
        $modules = search_query_generator(array($_GET['service']));
    }else{
        $body_sect .= 'ERROR: non-service';
        return;
    }
}
*/

$services = array(
    'catalog' => array('catalog_sect','catalog_goods'),
    'infosection' => 'infosection',
    'news'  => 'news',
    // 'blog'  => 'blog',
    'gallery'   => array('gallery','subgallery')
);

//       
foreach ($services as $k => $v) {
    if (!$loader->serviceActive($k)){
        unset($services[$k]);
    }
}

$active_services = array();
foreach ($services as $k => $v) {
    if (is_array($v)){
        foreach ($v as $v1) {
            $active_services[] = $v1;
        }
    }else{
        $active_services[] = $v;
    }
}


$modules = search_query_generator(
    $active_services
);

$header_sect .= '';
$searchQuery = '';
navigation::add_breadcrumb(' ', null);
if (empty($_GET['q'])) {
    $body_sect .= '<p>  </p>';
} elseif (!empty($_GET['q'])) {
    $pageNum = isset($_GET['page']) && is_numeric($_GET['page']) && $_GET['page'] > 0 ? (int) $_GET['page'] : 1;

    $searchStart = ($pageNum - 1) * RESULTS_ON_PAGE;
    $searchEnd = $searchStart + RESULTS_ON_PAGE;

    $searchQuery = trim($_GET['q']);
    $searchQuery = preg_replace('/[^\w\s\d-]/', '', $searchQuery);
    $searchQuery = preg_replace('/[\s]{2,}/', '', $searchQuery);
    $searchQuery = mysql_real_escape_string($searchQuery);
    if (strlen($searchQuery) > ($min_query_length-1) ) {

    $search_word = $searchQuery;

    $searchQuery = explode(' ',$searchQuery);
        $_tmpQuery = array();
    if (is_array($searchQuery)){
        foreach($searchQuery as $item){
            $_tmpQuery[] = '+'.$item.'*';
        }
        $searchQuery = $_tmpQuery;
    }
    $searchQuery = implode(' ',$searchQuery);


//  
if ($modules) {
    foreach ($modules as $table => $item) {
        //  
        if (is_array($item['search_text'])){
            $item['search_text'] = 'CONCAT('.implode(',',mysql_brackets($item['search_text'])).')';
        }else $item['search_text'] = '`'.$item['search_text'].'`';
        if (is_array($item['where'])){
            //     - where `visible`.   - where `visible`="1"
            $where = array();
            foreach ($item['where'] as $k => $v) {
                if (!is_numeric($k)){ //   
                    $where[] = '`'.$k.'`="'.$v.'"';
                }else $where[] = '`'.$v.'`';
            }
            $item['where'] = implode('AND',$where);
        }else $item['where'] = '`'.$item['where'].'`';
        // $baseQuery
        if (is_array($item['matches'])){
            $item['matches'] = implode(',', mysql_brackets($item['matches']));
        }else $item['matches'] = '`'.$item['matches'].'`';
        $baseQueries[$table] = '
            SELECT
                `'.$item['search_title'].'`    AS `search_title`, 
                 '.$item['search_text'].'      AS `search_text`, 
                `'.$item['object_id'].'`       AS `object_id`, 
                "'.$item['object_type'].'"     AS `object_type`
            FROM 
                `'.$table.'`
            WHERE 
                '.$item['where'].' 
                AND 
                MATCH('.$item['matches'].') AGAINST ("'.$searchQuery.'" IN BOOLEAN MODE)
            ';
    }
}else{
    $body_sect .= 'ERROR: non-modules';
    return;
}
if (is_array($baseQueries)){
    $sq         = array();
    $sq_count   = array();
    foreach ($baseQueries as $table => $query) {
        if ($_GET['service'] == $table){
            $sq_count[] = '('.$query.')';
            $sq[] = '('.$query. ' LIMIT ' . $searchStart . ', ' . $searchEnd . ')';
        }else{
            $sq[] = '('.$query.')';
        }
    }
    $baseQuery = implode('UNION',$sq);
    $countQuery = implode('UNION',$sq_count);

}else {
    $body_sect .= 'ERROR: non-array [queries]';
    return;
}

/*
$_baseQuery = <<<SQL
(
    select `name` as search_title, `content` as search_text, `id` as object_id, "catalog_sect" as object_type
    from `catalog_sect`
    where vis = 1 AND MATCH(`name`,`content`) AGAINST ("{$searchQuery}" IN BOOLEAN MODE)
)
union
(
    select `name` as search_title, `pre_content` as search_text, `id` as object_id, "catalog_goods" as object_type
    from `catalog_goods`
    where vis = 1 AND MATCH(`name`,`content`, `t_kod`) AGAINST ("{$searchQuery}" IN BOOLEAN MODE)
)
union
(
    select `name` as search_title, text as search_text, `id` as object_id, "section" as object_type
    from `infosection`
    where visible = 1 AND MATCH(`name`, `text`) AGAINST ("{$searchQuery}" IN BOOLEAN MODE)
)
union
(
    select `name` as search_title, CONCAT(`anons`, `text`) as search_text, `id` as object_id, "news" as object_type
    from `news`
    where visible = 1 AND MATCH(`name`, `anons`, `text`) AGAINST ("{$searchQuery}" IN BOOLEAN MODE)
)
union
(
    select `name` as search_title, CONCAT(`anons`, `text`) as search_text, `id` as object_id, "blog" as object_type
    from `blog`
    where visible = 1 AND MATCH(`name`, `anons`, `text`) AGAINST ("{$searchQuery}" IN BOOLEAN MODE)
)
union
(
    select `name` as search_title, `text` as search_text, `id` as object_id, "gallery" as object_type
    from `gallery`
    where visible = 1 AND MATCH(`name`,`text`) AGAINST ("{$searchQuery}" IN BOOLEAN MODE)
)

SQL;
//*/

    // ARRAY OF BOOLEAN VARIABLES - IDENTIFICATORS OF EXISTANCE OF "MORE RESUTS"
    $MORE_RESULTS = array();

        // $countQuery = $baseQuery;
        // if ($_GET['service']){
            // $sqlQuery = $baseQuery . ' LIMIT ' . $searchStart . ', ' . $searchEnd;
        // }
        $sqlQuery = $baseQuery;
        $resultCount = mysql_query($countQuery);
        $q = mysql_query($sqlQuery);
        if ($resultCount !== false && ($searchCount = mysql_num_rows($resultCount)) || (!$_GET['service'] && $q)){
            $pagesCount = ceil($searchCount / RESULTS_ON_PAGE);
            if ($q !== false && mysql_num_rows($q) > 0) {



                $goods       = new goods($db);
                $gallery     = new gallery($db);
                $catalog     = new catalog($db);
                $infosection = new infosection($db);

                //  
                $_RESULTS = array();
                $_RESULTS['catalog_goods']  = array();
                $_RESULTS['catalog_sect']   = array();
                $_RESULTS['infosection']    = array();
                $_RESULTS['subgallery']     = array();
                $_RESULTS['gallery']        = array();
                $_RESULTS['news']           = array();
                $_RESULTS['blog']           = array();

    $exploded_word = explode(' ',$search_word);
        while (false !== ($row = mysql_fetch_assoc($q))) {
            $__tmp = array();
                    if (!empty($row['object_id']) && !empty($row['object_type'])) {

                        if(++$RESULTS_COUNT[$row['object_type']] > RESULTS_EVERY_TABLE && !$_GET['service']) {
                            $MORE_RESULTS[$row['object_type']] = true;
                            continue;
                        }
                        switch ($row['object_type']) {
                            case 'catalog_goods':
                                $__tmp = $goods->getGood($row['object_id']);
                                if (!$catalog->checkVisible($__tmp['cid']))
                                    continue;
                                $catlog_url =  catalog::getUriById($__tmp['cid']);
                                $url = '/catalog/'. $catlog_url . '/' . $__tmp['id'] . '/';
                                $img_path = $__tmp['image'];
                                if ($img_path &&
                                    file_exists(rtrim(SR,'/').'/'.goods::$uploadFolder . catalog::$popPrefix . $img_path)
                                    ){
                                    $img = goods::$uploadFolder . catalog::$popPrefix . $img_path;
                                }
                                else $img = '';
                                $current = array_merge($__tmp,array(
                                    'url' => $url,
                                    'img' => $img,
                                ));
                                break;
                            case 'catalog_sect':
                                $current = $catalog->getCatalogById($row['object_id'],true);
                            break;
                            default:
                                if (strlen($row['search_text']) > 100) {
                                    $row['search_text'] = substr($row['search_text'], 0, 100) . '...';
                                }
                                $current = $row;
                                // $url = '/'.$row['object_type'].'/'.$row['object_id'].'/';
                                break;
                        }
                        $_RESULTS[$row['object_type']][] = $current;
                    }
                    $row['search_text'] = strip_tags($row['search_text'], '<br><p>');
                    if (strlen($row['search_text']) > 100) {
                        $row['search_text'] = substr($row['search_text'], 0, 100) . '...';
                    }
                }
                


    // foreach ($_RESULTS as $SERVICE => $DATA) switch ($SERVICE) 
        {

                /*   */
                // case 'catalog_sect' :
                if ($DATA = &$_RESULTS['catalog_sect'])
                if (!isset($_GET['service']) || $_GET['service'] == 'catalog_sect')
                {
                    $items = '';
                    $subcatalogs = '';
                    $num=0;
                    //   20,    
                    foreach($DATA as $child){
                        
                        $uri = $catalog->getUriById($child['id']);
                        $child['href'] = "/catalog/{$uri}/";
                        $child['image'] = $catalog->getImage($child['id']);
                        $child['image'] = $child['image']['image'];
                        $preview_image = catalog::$uploadFolder . catalog::$popPrefix . $child['image'];
                        $preview_image = $preview_image['image'];
                        $preview_thumb = noimg('catalog');
                        if (!empty($exploded_word)){
                            foreach($exploded_word as $word){
                                $child['name'] = str_replace($word,'<span class="red_highlight b">'.$word.'</span>',strtolower($child['name']));
                            }
                        }
                        if ($child['image'] != false) {
                            $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $preview_image;
                            if (file_exists($preview_thumb_file)) {
                                $preview_thumb = $preview_image;
                            }
                        }
                        $subcatalogs .= $item_render
                                      ->clear()
                                      ->set('catalog', $child)
                                      ->set('preview_thumb', $preview_thumb)
                                      ->render('/catalog/item2.php');
                    }
                    if ($subcatalogs){
                        $subcatalogs = '<h2></h2>'.$render->renderWrap("/catalog/list.php", $subcatalogs);
                        $final_render .= $render
                                        ->clear()
                                        ->set('children', $subcatalogs)
                                        ->render("/catalog/show.php");
                    }
                    if ($MORE_RESULTS['catalog_sect']){
                        $subcatalogs .= btn_more('catalog_sect');
                    }


                    // break;
                }





                /*  */






                // case 'catalog_goods':{
                if ($DATA = &$_RESULTS['catalog_goods'])
                if (!isset($_GET['service']) || $_GET['service'] == 'catalog_goods')
                {
                    $items = '';
                        foreach ($DATA as $item) {
                            if (!$item['vis'])
                                continue;

                            $filename = $item['image'];
                            if ($item['image'] != '') {
                                $item_preview = array(
                                    'image' => catalog::$uploadFolder . $item['image'],
                                    'thumb' => catalog::$uploadFolder . catalog::$popPrefix . $item['image']
                                );
                            } else {
                                $item_preview = false;
                            }
                            // 
                            $stock_data = array();
                            if($item['stock_data']){
                                $stock_data = unserialize($item['stock_data']);
                                $stock_data = $stock->loadById(key($stock_data));
                            }
                            $preview_thumb = noimg('goods');
                            if ($item_preview != false) {
                                $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $item_preview['thumb'];
                                if (file_exists($preview_thumb_file)) {
                                    $preview_thumb = $item_preview['thumb'];
                                }
                            }
                            
                            $uri = $catalog->getUriById($item['cid']);
                            $item['href'] = "/catalog/{$uri}/{$item['uri']}/";
                            if (!empty($exploded_word)){
                                foreach($exploded_word as $word){
                                    $item['name'] = str_replace($word,'<span class="red_highlight b">'.$word.'</span>',strtolower($item['name']));
                                }
                            }
                            $items .= $item_render
                                    ->clear()
                                    ->set('item', $item)
                                    ->set('stock', $stock_data)
                                    ->set('preview_thumb', $preview_thumb)
                                    ->render("/catalog/good/item.php");
                            $i_num++;
                            $items .='<div class="separ"></div>';
                        }
                        $items       = '<h2></h2>'.$render->renderWrap("/catalog/good/list.php", $items);
                    if ($MORE_RESULTS['catalog_goods']){
                        $items .= btn_more('catalog_goods');
                    }
                    $final_render .= $render
                                    ->clear()
                                    ->set('items', $items)
                                    ->render("/catalog/show.php");
                    // break;
                }
                




                /*  */



                // case 'infosection' : {
                if ($DATA = &$_RESULTS['infosection'])
                if (!isset($_GET['service']) || $_GET['service'] == 'infosection')
                {
                    $infosection->load();

                    $final_render .='
                    <h2></h2>
                    <div class="search-sections">
                    <div class="cat-sim"><ul>';
                    foreach($DATA as $item){
                        if (!empty($exploded_word)){
                            foreach($exploded_word as $word){
                                $item['search_title'] = str_replace($word,'<span class="red_highlight b">'.$word.'</span>',strtolower($item['search_title']));
                            }
                        }
                        $final_render .='<li>
                        <a href="'.$infosection->get_cannon_url($item['object_id']).'/">'.$item['search_title'].'</a>
                        '.strip_tags($item['search_text']).'
                        </li>';
                    }
                    $final_render .= '
                        </ul></div>
                            <div class="lt"></div>
                            <div class="rt"></div>
                            <div class="rb"></div>
                            <div class="lb"></div>
                        </div>';
                        if ($MORE_RESULTS['infosection']){
                            $final_render .= btn_more('infosection');
                        }
                    // break;
                }
                
                // case 'news' : {
                if ($DATA = &$_RESULTS['news'])
                if (!isset($_GET['service']) || $_GET['service'] == 'news')
                {

                    $final_render .='
                        <h2></h2>
                        <div class="toyb">
                        <div class="cat-sim"><ul>';
                    foreach($DATA as $item){
                        if (!empty($exploded_word)){
                            foreach($exploded_word as $word){
                                $item['search_title'] = str_replace($word,'<span class="red_highlight b">'.$word.'</span>',strtolower($item['search_title']));
                            }
                        }
                        $final_render .='<li>
                        <a href="/news/'.$item['object_id'].'/">'.$item['search_title'].'</a>
                        '.$item['search_text'].'
                        </li>';
                    }
                    $final_render .= '
                        </ul></div>
                            <div class="lt"></div>
                            <div class="rt"></div>
                            <div class="rb"></div>
                            <div class="lb"></div>
                        </div>';

                        if ($MORE_RESULTS['news']){
                            $final_render .= btn_more('news');
                        }
                    // break;
                }



                // case 'blog' : {
                if ($DATA = &$_RESULTS['blog'])
                if (!isset($_GET['service']) || $_GET['service'] == 'blog')
                {
                    $final_render .='
                        <h2></h2>
                        <div class="toyb">
                        <div class="cat-sim"><ul>';
                    foreach($DATA as $item){
                        if (!empty($exploded_word)){
                            foreach($exploded_word as $word){
                                $item['search_title'] = str_replace($word,'<span class="red_highlight b">'.$word.'</span>',strtolower($item['search_title']));
                            }
                        }
                        $final_render .='<li>
                        <a href="/blog/post/'.$item['object_id'].'/">'.$item['search_title'].'</a>
                        '.$item['search_text'].'
                        </li>';
                    }
                    $final_render .= '
                        </ul></div>
                            <div class="lt"></div>
                            <div class="rt"></div>
                            <div class="rb"></div>
                            <div class="lb"></div>
                        </div>';

                        if ($MORE_RESULTS['blog']){
                            $final_render .= btn_more('blog');
                        }
                    // break;
                }

                // case 'gallery' : 
                if ($DATA = &$_RESULTS['gallery'])
                if (!isset($_GET['service']) || $_GET['service'] == 'gallery')
                {
                    $items = '';
                    $final_render .='<h2></h2>';
                    
                    $data = $gallery->load();
                    foreach($DATA as $item){
                        if (!empty($exploded_word)){
                            foreach($exploded_word as $word){
                                $item['search_title'] = str_replace($word,'<span class="red_highlight b">'.$word.'</span>',strtolower($item['search_title']));
                            }
                        }
                        $v = $data[$item['object_id']];
                        if ($v){
                            if ($v['image']){
                                if (is_file(SR.$gallery->getPath().$v['image'])){
                                    $v['image'] = $gallery->getPath().$v['image'];
                                }else{
                                    $v['image'] = noimg('gallery');
                                }
                            }else $v['image'] = noimg();
                            
                            $items .= $item_render
                                         ->clear()
                                         ->set('item', $v)
                                         ->render('/gallery/item.php');
                        }
                    }
                    
                    if ($items){
                        $final_render .= $render->renderWrap("/gallery/list.php", $items);
                    }
                    if ($MORE_RESULTS['gallery']){
                        $final_render .= btn_more('gallery');
                    }
                    // break;
                }
                
                // case 'subgallery' : 
                if ($DATA = &$_RESULTS['subgallery'])
                if (!isset($_GET['service']) || $_GET['service'] == 'subgallery')
                {
                    $items = '';
                    $final_render .='<h2></h2>';
                    $subgallery = new subgallery($db);
                    foreach($DATA as $item){
                        $v = array();
                        $v['name'] = $item['search_title'];
                        $v['image'] = $item['search_text'];
                        if ($v){
                            if ($v['image']){
                                $img = $v['image'];
                                if (is_file(SR.ltrim(subgallery::$path).$subgallery->preview_prefix[0].$img)){
                                    $v['image'] = subgallery::$path.$subgallery->preview_prefix[0].$img;
                                }else{
                                    $v['image'] = noimg('subgallery');
                                }
                                if (is_file(SR.ltrim(subgallery::$path).$img)){
                                    $v['href'] = subgallery::$path.$img;
                                }else{
                                    $v['href'] = noimg('subgallery');
                                }
                            }else $v['image'] = noimg();
                            
                            $items .= $item_render
                                         ->clear()
                                         ->set('item', $v)
                                         ->render('/gallery/album/item.php');
                        }
                    }
                    
                    if ($items){
                        $final_render .= $render->renderWrap("/gallery/album/list.php", $items);
                    }
                    if ($MORE_RESULTS['gallery']){
                        $final_render .= btn_more('gallery');
                    }
                    // break;
                }
    } // END OF $_RESULTS FOREACH



                $body_sect .= '<div class="search-status"> : <span class="red_highlight b search-query">'.$search_word.'</span>'.($_GET['service'] ? '   <strong class="search-group">'.($modules_configs[$_GET['service']]['title']).'</strong>' : '').'</div>';
                
                if ($_RESULTS){
                   $body_sect .= '
                    <ul class="nav nav-pills nav-search" style="padding:10px 0;">';
                    $body_sect .= '<li class="'.(!$_GET['service'] ? 'active' : '').'"><a href="/search/?q='.$_GET['q'].'">  </a></li>';
                    foreach ($_RESULTS as $k => $v) {
                        if (!$v) continue;
                        
                        $service = $modules_configs[$k];
                        $body_sect .=                       
                            '<li class="'.($_GET['service'] == $k ? 'active' : '').'"><a href="/search/?q='.$_GET['q'].'&service='.$k.'">'.$service['title'].'</a></li>';
                    }                
                    $body_sect .= '</ul>';
                }

                $body_sect .= $_GET['service'] ? '<div style="text-align:right;"><a href="/search/?q='.$_GET['q'].'">    </a></div>' : '';

                $body_sect .= $final_render;
                
                if ($searchEnd) {
                    if ($searchEnd > $searchCount) {
                        $searchEnd = $searchCount;
                    }
                }
                if ($_GET['service']){
                    $body_sect .= renderPager($searchCount, $pageNum, RESULTS_ON_PAGE, '?q='.$_GET['q'].'&service='.$_GET['service'].'&page={page}');
                }
            }else{
                $body_sect .= '<p>     </p>';
            }
        } else {
            $body_sect .= '<p>     </p>';
        }
    }
    else {
        $body_sect .= '<p>     - <b>'.$min_query_length.'</b></p>';
    }
}
?>
