<?php

if (!$loader->serviceActive('infosection'))
   { go404(); return;}

class inc_section {
    protected $_infosection;

    public function __construct(infosection $infosection) {
        $this->_infosection = $infosection;
    }

    protected function replace_comment($text, $replace, $body_sect) {
        $comment = '<!--' . $text . '-->';
        if (strpos($body_sect, $comment) !== false) {
            return str_replace($comment, $replace, $body_sect);
        } else {
            return $body_sect . $replace;
        }
    }

    protected function replace_text($text, $replace, $body_sect) {
        $text = '[' . $text . ']';

        if (strpos($body_sect, '<p style="font-weight:bold">' . $text  . '</p>') !== false) {
            return str_replace('<p style="font-weight:bold">' . $text  . '</p>', $replace, $body_sect);
        } elseif (strpos($body_sect, '<span style="font-weight:bold">' . $text  . '</span>') !== false) {
            return str_replace('<span style="font-weight:bold">' . $text  . '</span>', $replace, $body_sect);
        } elseif (strpos($body_sect, $text) !== false) {
            return str_replace($text, $replace, $body_sect);
        } else {
            return $body_sect . $replace;
        }
    }

    function render_active_infosection($id, $cannon = false) {
        global $template, $body_sect, $header_sect, $db;
        $render = new Template();
        $item_render = new Template();

        $infosection = $this->_infosection;
        $infosection->id = (int) $id;
        $infosection->load();
        if (!$infosection->curent) return false;
        //    - 
        // if ($infosection->curent['uri']){
            // $uri = $infosection->get_cannon_url($id);
            // header('Location: '.$uri);
            // var_dump($uri);die();
        // }
        $active_array = $infosection->get_parrent_array($infosection->id);
        $body_sect = '';
        $header_sect = $infosection->curent['name'];

        $status_string = '';
        $active_array = array_reverse($active_array);
		
        foreach ($active_array as $v) {
            
                navigation::add_active_item("infosection", (int) $v);
                if ($v) {
                    navigation::add_breadcrumb($infosection->data[$v]['name'], $infosection->get_cannon_url($v));
                }
            
        }
        navigation::add_active_item("infosection", (int) $infosection->id);
        $subgallery = new subgallery($db);
        $subgallery->load($infosection->id, 'infosection');
        $header_sect = $infosection->curent['hide-title'] ? '' : $infosection->curent['name'];

        $infosection->curent['text'] = find_pretext($infosection->curent['text']);    
        $body_sect .= $infosection->curent['text'];
        $script = trim($infosection->curent['code']);
        if ($script) {
            $body_sect = $this->replace_comment('code', $script, $body_sect);
        }

        if ($subgallery->gallery) {
            $p = subgallery::$path;
            $gallery_items = '';
            $gallery = '';
            
            foreach ($subgallery->gallery as $v) {
                if (!$v['visible'])
                    continue;
                $v['href'] = $p.$v['file'];
                $v['image'] = $p.'s'.$v['file'];
                $gallery_items .= $item_render
                         ->clear()
                         ->set('item', $v)
                         ->render('/gallery/album/item.php');
            }

            if ($gallery_items){
                $body_sect .= $render
                        ->set('items', $gallery_items)
                        ->render("/gallery/album/list.php");
            }
        }

        $seo = new seo($db, 'infosection', $infosection->id, 'main');
        $seo->populateMetaTags($seo->get_seo());

        // $config = config::load();


        /*switch ($id) {
            case ($config->sections->base_register):
                $forms = new forms($db);
                $error = array();
                $form = $forms->load_on_alias('base-register');

                $course = new course();
                $values['date'] = $course->get_course_days();
                if ($forms->submit($errors, $values)) {
                    $form = '<div class="form_response">' . meno_translate('  .') . '</div>';
                } else {
                    $form = show_form($form, $_REQUEST, $errors, $values);
                }
                $form = '<div id="generated_form">' . $form . '</div>';
                $body_sect = $this->replace_text('', $form, $body_sect);
                break;
        }*/
        return true;
    }
}

if ($db->qa[0] == 'section') {
    $infosection = new infosection($db);
    $render = new inc_section($infosection);
    $render->render_active_infosection($db->qa[1]) or go404();
}
?>